# its4land_public_api

Its4landPublicApi - JavaScript client for its4land_public_api
The its4land Public API provides access to the services of the its4land Publish and Share platform.
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.0.2
- Package version: 0.0.2
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen
For more information, please visit [https://its4land.com](https://its4land.com)

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install its4land_public_api --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your its4land_public_api from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('its4land_public_api')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var Its4landPublicApi = require('its4land_public_api');

var api = new Its4landPublicApi.AdminSourcesApi()

var adminsourceUid = "adminsourceUid_example"; // {String} AdminSource UID

var opts = { 
  'envelope': "envelope_example", // {String} The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // {[String]} Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.getAdminSourceByUID(adminsourceUid, opts, callback);

```

## Documentation for API Endpoints

All URIs are relative to *https://platform.its4land.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Its4landPublicApi.AdminSourcesApi* | [**getAdminSourceByUID**](docs/AdminSourcesApi.md#getAdminSourceByUID) | **GET** /adminsources/{adminsource_uid} | Returns a single Admin Source
*Its4landPublicApi.AdminSourcesApi* | [**getAdminSources**](docs/AdminSourcesApi.md#getAdminSources) | **GET** /adminsources | Returns a list of AdminSource document indizes
*Its4landPublicApi.AdminSourcesApi* | [**newAdminSource**](docs/AdminSourcesApi.md#newAdminSource) | **POST** /adminsources | Creates a new AdminSource
*Its4landPublicApi.AdminSourcesApi* | [**updateAdminSource**](docs/AdminSourcesApi.md#updateAdminSource) | **PATCH** /adminsources/{adminsource_uid} | Update an Admin Source
*Its4landPublicApi.BoundaryFaceStringApi* | [**getBoundaryFaceString**](docs/BoundaryFaceStringApi.md#getBoundaryFaceString) | **GET** /boundaryfacestring | Returns a list of boundary face strings in a GeoJSON structure.
*Its4landPublicApi.BoundaryFaceStringApi* | [**getBoundaryFaceStringByUID**](docs/BoundaryFaceStringApi.md#getBoundaryFaceStringByUID) | **GET** /boundaryfacestring/{boundaryfacestring_uid} | Returns a single boundary face string
*Its4landPublicApi.BoundaryFaceStringApi* | [**newBoundaryFaceString**](docs/BoundaryFaceStringApi.md#newBoundaryFaceString) | **POST** /boundaryfacestring | Create a new concept for a boundary face string
*Its4landPublicApi.BoundaryFaceStringApi* | [**putBoundaryFaceStringByUID**](docs/BoundaryFaceStringApi.md#putBoundaryFaceStringByUID) | **PUT** /boundaryfacestring/{boundaryfacestring_uid} | Replace an existing BoundaryFaceString by a newer version
*Its4landPublicApi.BoundaryFaceStringApi* | [**updateBoundaryFaceString**](docs/BoundaryFaceStringApi.md#updateBoundaryFaceString) | **PATCH** /boundaryfacestring/{boundaryfacestring_uid} | Updates a boundary face string
*Its4landPublicApi.ClassifierApi* | [**getClassifier**](docs/ClassifierApi.md#getClassifier) | **GET** /classifier | Returns a list of classifier
*Its4landPublicApi.ClassifierApi* | [**getClassifierByUID**](docs/ClassifierApi.md#getClassifierByUID) | **GET** /classifier/{classifier_id} | Returns a single classifier.
*Its4landPublicApi.ClassifierApi* | [**newClassifier**](docs/ClassifierApi.md#newClassifier) | **POST** /classifier | Create a new classifier
*Its4landPublicApi.ContentItemsApi* | [**getContentItem**](docs/ContentItemsApi.md#getContentItem) | **GET** /contentitems/{contentitem_id} | Returns a single content from the object storage.
*Its4landPublicApi.ContentItemsApi* | [**getContentItems**](docs/ContentItemsApi.md#getContentItems) | **GET** /contentitems | Returns a list of contentitems
*Its4landPublicApi.ContentItemsApi* | [**newContentItem**](docs/ContentItemsApi.md#newContentItem) | **POST** /contentitems | Create a new content in the object storage
*Its4landPublicApi.MetricMapFeaturesApi* | [**getMetricMapFeature**](docs/MetricMapFeaturesApi.md#getMetricMapFeature) | **GET** /metricmapfeature | Returns MetricMapFeature
*Its4landPublicApi.MetricMapFeaturesApi* | [**newMetricMapFeature**](docs/MetricMapFeaturesApi.md#newMetricMapFeature) | **POST** /metricmapfeature | Create a new metricMapFeature
*Its4landPublicApi.MetricMapFeaturesApi* | [**updateMetricMapFeature**](docs/MetricMapFeaturesApi.md#updateMetricMapFeature) | **PATCH** /metricmapfeature/{mmf_uid} | Updates a metric map feature
*Its4landPublicApi.MiscApi* | [**getDDILayers**](docs/MiscApi.md#getDDILayers) | **GET** /DDILayers | Return a list of registered DDI (WFS/WMS) Layer
*Its4landPublicApi.MiscApi* | [**getPuSConfig**](docs/MiscApi.md#getPuSConfig) | **GET** /PuSConfig | Returns a list of configuration parameters as Key Value
*Its4landPublicApi.MiscApi* | [**newDDILayers**](docs/MiscApi.md#newDDILayers) | **POST** /DDILayers | Register a new DDI (WFS/WMS) Layer
*Its4landPublicApi.ModelClassesApi* | [**getModelClasses**](docs/ModelClassesApi.md#getModelClasses) | **GET** /modelclasses | Returns ModelClasses
*Its4landPublicApi.ModelClassesApi* | [**getModelClassesByUID**](docs/ModelClassesApi.md#getModelClassesByUID) | **GET** /modelclasses/{modelclasses_uid} | Returns a single model class
*Its4landPublicApi.ModelClassesApi* | [**updateModelClasses**](docs/ModelClassesApi.md#updateModelClasses) | **PATCH** /modelclasses/{modelclasses_uid} | Updates some attributes of a ModelClass
*Its4landPublicApi.ModelsApi* | [**getModels**](docs/ModelsApi.md#getModels) | **GET** /models | Returns a list of models.
*Its4landPublicApi.ModelsApi* | [**getModelsByUID**](docs/ModelsApi.md#getModelsByUID) | **GET** /models/{model_uid} | Returns a single model
*Its4landPublicApi.ModelsApi* | [**getModelsClassesByModel**](docs/ModelsApi.md#getModelsClassesByModel) | **GET** /models/{model_uid}/modelclasses | Returns the model classes of the classifier.
*Its4landPublicApi.ModelsApi* | [**newModel**](docs/ModelsApi.md#newModel) | **POST** /models | Create a new model
*Its4landPublicApi.ModelsApi* | [**newModelClassUnderModel**](docs/ModelsApi.md#newModelClassUnderModel) | **POST** /models/{model_uid}/modelclasses | Create a new ModelClass under a model
*Its4landPublicApi.ModelsApi* | [**updateModels**](docs/ModelsApi.md#updateModels) | **PATCH** /models/{model_uid} | Updates some attributes of a model
*Its4landPublicApi.ProcessesApi* | [**createProcessLog**](docs/ProcessesApi.md#createProcessLog) | **POST** /processes/{process_uid}/log | Writes a single log entry
*Its4landPublicApi.ProcessesApi* | [**createProcesses**](docs/ProcessesApi.md#createProcesses) | **POST** /processes | Creates a new  processes
*Its4landPublicApi.ProcessesApi* | [**getProcessByUID**](docs/ProcessesApi.md#getProcessByUID) | **GET** /processes/{process_uid} | Returns metadata for a single process
*Its4landPublicApi.ProcessesApi* | [**getProcessLog**](docs/ProcessesApi.md#getProcessLog) | **GET** /processes/{process_uid}/log | Get the full log of a process
*Its4landPublicApi.ProcessesApi* | [**getProcesses**](docs/ProcessesApi.md#getProcesses) | **GET** /processes | Get a list of processes
*Its4landPublicApi.ProjectsApi* | [**addTagToProject**](docs/ProjectsApi.md#addTagToProject) | **POST** /projects/{project_uid}/Tags | Adds a tag to the project
*Its4landPublicApi.ProjectsApi* | [**delProjectByUID**](docs/ProjectsApi.md#delProjectByUID) | **DELETE** /projects/{project_uid} | Deletes a single e project by its UID
*Its4landPublicApi.ProjectsApi* | [**detachProjectModel**](docs/ProjectsApi.md#detachProjectModel) | **DELETE** /projects/{project_uid}/Models/{model_uid} | Removes a model from a project.
*Its4landPublicApi.ProjectsApi* | [**detachProjectSpatialSource**](docs/ProjectsApi.md#detachProjectSpatialSource) | **DELETE** /projects/{project_uid}/SpatialSources/{spatialsource_uid} | Removes a spatialsource from a project.
*Its4landPublicApi.ProjectsApi* | [**detachProjectTag**](docs/ProjectsApi.md#detachProjectTag) | **DELETE** /projects/{project_uid}/Tags/{tag} | Removes a tag from a project.
*Its4landPublicApi.ProjectsApi* | [**getConnectedObjectsByProjectUID**](docs/ProjectsApi.md#getConnectedObjectsByProjectUID) | **GET** /projects/{project_uid}/connectedObjects | Returns an array of connect objects
*Its4landPublicApi.ProjectsApi* | [**getModelsByProjectUID**](docs/ProjectsApi.md#getModelsByProjectUID) | **GET** /projects/{project_uid}/Models | Returns the models of a project
*Its4landPublicApi.ProjectsApi* | [**getProjectTagsByProjectUID**](docs/ProjectsApi.md#getProjectTagsByProjectUID) | **GET** /projects/{project_uid}/Tags | Returns the tags of a project.
*Its4landPublicApi.ProjectsApi* | [**getProjects**](docs/ProjectsApi.md#getProjects) | **GET** /projects | Get a GeoJSON structure containing a list of Projects.
*Its4landPublicApi.ProjectsApi* | [**getProjectsByUID**](docs/ProjectsApi.md#getProjectsByUID) | **GET** /projects/{project_uid} | Getting single Projects by its UID
*Its4landPublicApi.ProjectsApi* | [**getSpatialSourceByProjectUID**](docs/ProjectsApi.md#getSpatialSourceByProjectUID) | **GET** /projects/{project_uid}/SpatialSources | Returns the SpatialSources of a Project.
*Its4landPublicApi.ProjectsApi* | [**newModelUnderProject**](docs/ProjectsApi.md#newModelUnderProject) | **POST** /projects/{project_uid}/Models | Create a new model
*Its4landPublicApi.ProjectsApi* | [**newProject**](docs/ProjectsApi.md#newProject) | **POST** /projects | Create a new project
*Its4landPublicApi.ProjectsApi* | [**newSpatialSourceUnderProject**](docs/ProjectsApi.md#newSpatialSourceUnderProject) | **POST** /projects/{project_uid}/SpatialSources | Create a new SpatialSource
*Its4landPublicApi.ProjectsApi* | [**updateProjects**](docs/ProjectsApi.md#updateProjects) | **PATCH** /projects/{project_uid} | Update a project
*Its4landPublicApi.SpatialSourcesApi* | [**detachSpatialSourceAddDoc**](docs/SpatialSourcesApi.md#detachSpatialSourceAddDoc) | **DELETE** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Removes an additional document for a spatial source.
*Its4landPublicApi.SpatialSourcesApi* | [**getSpatialSourceAddDocs**](docs/SpatialSourcesApi.md#getSpatialSourceAddDocs) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument | Returns the additional documents of a spatial source
*Its4landPublicApi.SpatialSourcesApi* | [**getSpatialSourceByUID**](docs/SpatialSourcesApi.md#getSpatialSourceByUID) | **GET** /spatialsource/{spatialsource_uid} | Returns a single SpatialSource
*Its4landPublicApi.SpatialSourcesApi* | [**getSpatialSourceSingleAddDoc**](docs/SpatialSourcesApi.md#getSpatialSourceSingleAddDoc) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Returns the additional documents of a spatial source
*Its4landPublicApi.SpatialSourcesApi* | [**getSpatialSources**](docs/SpatialSourcesApi.md#getSpatialSources) | **GET** /spatialsources | Returns a list of SpatialSources
*Its4landPublicApi.SpatialSourcesApi* | [**newSpatialSource**](docs/SpatialSourcesApi.md#newSpatialSource) | **POST** /spatialsources | Create a new SpatialSource
*Its4landPublicApi.SpatialSourcesApi* | [**newSpatialSourceAddAddDoc**](docs/SpatialSourcesApi.md#newSpatialSourceAddAddDoc) | **POST** /spatialsource/{spatialsource_uid}/AdditionalDocument | Add a new additional document to a spatial source
*Its4landPublicApi.SpatialSourcesApi* | [**putSpatialSourceByUID**](docs/SpatialSourcesApi.md#putSpatialSourceByUID) | **PUT** /spatialsource/{spatialsource_uid} | Replace an existing SpatialSource by a newer version
*Its4landPublicApi.SpatialUnitsApi* | [**create2PpolygonSPUfromBFS**](docs/SpatialUnitsApi.md#create2PpolygonSPUfromBFS) | **POST** /spatialunits/create2Dpolygonspatialunit | Creates a spatial unit
*Its4landPublicApi.SpatialUnitsApi* | [**getSpatialUnitByUID**](docs/SpatialUnitsApi.md#getSpatialUnitByUID) | **GET** /spatialunits/qualitative/{spatialunit_uid} | Returns a single spatial unit
*Its4landPublicApi.SpatialUnitsApi* | [**getSpatialUnitConceptByUID**](docs/SpatialUnitsApi.md#getSpatialUnitConceptByUID) | **GET** /spatialunits/concepts/{concept_uid} | Returns a single spatial unit concept
*Its4landPublicApi.SpatialUnitsApi* | [**getSpatialUnits**](docs/SpatialUnitsApi.md#getSpatialUnits) | **GET** /spatialunits | Returns a list of SpatialUnits in a GeoJSON structure.
*Its4landPublicApi.SpatialUnitsApi* | [**getSpatialUnitsByUUID**](docs/SpatialUnitsApi.md#getSpatialUnitsByUUID) | **GET** /spatialunits/{spatialunit_uid} | Returns a list of SpatialUnits
*Its4landPublicApi.SpatialUnitsApi* | [**getSpatialUnitsConcepts**](docs/SpatialUnitsApi.md#getSpatialUnitsConcepts) | **GET** /spatialunits/concepts | Returns a list of spatial units concepts
*Its4landPublicApi.SpatialUnitsApi* | [**getSpatialUnitsQualitative**](docs/SpatialUnitsApi.md#getSpatialUnitsQualitative) | **GET** /spatialunits/qualitative | Returns a list of SpatialUnits
*Its4landPublicApi.SpatialUnitsApi* | [**newSpatialUnit**](docs/SpatialUnitsApi.md#newSpatialUnit) | **POST** /spatialunits | Create a new SpatialUnit
*Its4landPublicApi.SpatialUnitsApi* | [**newSpatialUnitConcept**](docs/SpatialUnitsApi.md#newSpatialUnitConcept) | **POST** /spatialunits/concepts | Create a new concept for a spatial unit
*Its4landPublicApi.SpatialUnitsApi* | [**newSpatialUnitQualitative**](docs/SpatialUnitsApi.md#newSpatialUnitQualitative) | **POST** /spatialunits/qualitative | Create a new SpatialUnit
*Its4landPublicApi.SpatialUnitsApi* | [**updateSpatialUnit**](docs/SpatialUnitsApi.md#updateSpatialUnit) | **PATCH** /spatialunits/{spatialunit_uid} | Update an spatial unit
*Its4landPublicApi.SpatialUnitsApi* | [**updateSpatialUnitConcept**](docs/SpatialUnitsApi.md#updateSpatialUnitConcept) | **PATCH** /spatialunits/concepts/{concept_uid} | Updates a new spatial unit concept
*Its4landPublicApi.SpatialUnitsApi* | [**updateSpatialUnitQualitative**](docs/SpatialUnitsApi.md#updateSpatialUnitQualitative) | **PATCH** /spatialunits/qualitative/{spatialunit_uid} | Updates a new SpatialUnit
*Its4landPublicApi.TagsApi* | [**getTagByName**](docs/TagsApi.md#getTagByName) | **GET** /tags/{tag_name} | Returns a single tag
*Its4landPublicApi.TagsApi* | [**getTags**](docs/TagsApi.md#getTags) | **GET** /tags | Get a list of tags
*Its4landPublicApi.TagsApi* | [**mergeTagByUID**](docs/TagsApi.md#mergeTagByUID) | **PATCH** /tags/{tag_uid}/merge | Merge tags
*Its4landPublicApi.TagsApi* | [**updateTagByName**](docs/TagsApi.md#updateTagByName) | **PATCH** /tags/{tag_name} | Updates a tag
*Its4landPublicApi.ToolsApi* | [**getTools**](docs/ToolsApi.md#getTools) | **GET** /tools | Get a list of tools
*Its4landPublicApi.TrainingSetsApi* | [**getTrainingSetByUID**](docs/TrainingSetsApi.md#getTrainingSetByUID) | **GET** /trainingsets/{trainingsets_uid} | Returns a single TrainingSet
*Its4landPublicApi.TrainingSetsApi* | [**getTrainingSets**](docs/TrainingSetsApi.md#getTrainingSets) | **GET** /trainingsets | Returns a list of TrainingSets
*Its4landPublicApi.TrainingSetsApi* | [**newTrainingSet**](docs/TrainingSetsApi.md#newTrainingSet) | **POST** /trainingsets | Create a new TrainingSet
*Its4landPublicApi.WP5ValidationSetsApi* | [**getWP5ValidationSetByUID**](docs/WP5ValidationSetsApi.md#getWP5ValidationSetByUID) | **GET** /WP5ValidationSets/{wp5validationset_uid} | Returns a single WP5ValidationSet
*Its4landPublicApi.WP5ValidationSetsApi* | [**getWP5ValidationSets**](docs/WP5ValidationSetsApi.md#getWP5ValidationSets) | **GET** /WP5ValidationSets | Returns a list of WP5ValidationSets
*Its4landPublicApi.WP5ValidationSetsApi* | [**newWP5ValidationSets**](docs/WP5ValidationSetsApi.md#newWP5ValidationSets) | **POST** /WP5ValidationSets | Create a new WP5ValidationSets


## Documentation for Models

 - [Its4landPublicApi.AdditionalDocumentsEndpointType](docs/AdditionalDocumentsEndpointType.md)
 - [Its4landPublicApi.AdditionalDocumentsPost](docs/AdditionalDocumentsPost.md)
 - [Its4landPublicApi.AdminSourcesEndpointType](docs/AdminSourcesEndpointType.md)
 - [Its4landPublicApi.AdminSourcesEndpointTypeSpatialUnits](docs/AdminSourcesEndpointTypeSpatialUnits.md)
 - [Its4landPublicApi.AdminSourcesPostRequest](docs/AdminSourcesPostRequest.md)
 - [Its4landPublicApi.BoundaryFaceStringEndpointType](docs/BoundaryFaceStringEndpointType.md)
 - [Its4landPublicApi.BoundaryFaceStringEndpointTypeFeatures](docs/BoundaryFaceStringEndpointTypeFeatures.md)
 - [Its4landPublicApi.BoundaryFaceStringEndpointTypeGeometry](docs/BoundaryFaceStringEndpointTypeGeometry.md)
 - [Its4landPublicApi.BoundaryFaceStringEndpointTypeProperties](docs/BoundaryFaceStringEndpointTypeProperties.md)
 - [Its4landPublicApi.BoundaryFaceStringEndpointTypePropertiesSpatialUnit](docs/BoundaryFaceStringEndpointTypePropertiesSpatialUnit.md)
 - [Its4landPublicApi.BoundaryFaceStringPostRequest](docs/BoundaryFaceStringPostRequest.md)
 - [Its4landPublicApi.BoundaryFaceStringPostRequestFeatures](docs/BoundaryFaceStringPostRequestFeatures.md)
 - [Its4landPublicApi.BoundaryFaceStringPostRequestProperties](docs/BoundaryFaceStringPostRequestProperties.md)
 - [Its4landPublicApi.ClassifierEndpointType](docs/ClassifierEndpointType.md)
 - [Its4landPublicApi.ClassifierPostRequest](docs/ClassifierPostRequest.md)
 - [Its4landPublicApi.ConnectedObjectsEndpointType](docs/ConnectedObjectsEndpointType.md)
 - [Its4landPublicApi.ConnectedObjectsEndpointTypeInner](docs/ConnectedObjectsEndpointTypeInner.md)
 - [Its4landPublicApi.ContentItemEndpointType](docs/ContentItemEndpointType.md)
 - [Its4landPublicApi.DDILayersEndpointType](docs/DDILayersEndpointType.md)
 - [Its4landPublicApi.DDILayersPostRequest](docs/DDILayersPostRequest.md)
 - [Its4landPublicApi.ImageSetsEndpointType](docs/ImageSetsEndpointType.md)
 - [Its4landPublicApi.ImageSetsEndpointTypeContentItems](docs/ImageSetsEndpointTypeContentItems.md)
 - [Its4landPublicApi.ImageSetsEndpointTypeMetadata](docs/ImageSetsEndpointTypeMetadata.md)
 - [Its4landPublicApi.LogEntryEndpointType](docs/LogEntryEndpointType.md)
 - [Its4landPublicApi.LogEntryPostRequest](docs/LogEntryPostRequest.md)
 - [Its4landPublicApi.MetricMapFeaturePostRequest](docs/MetricMapFeaturePostRequest.md)
 - [Its4landPublicApi.MetricMapFeaturePostRequestProperties](docs/MetricMapFeaturePostRequestProperties.md)
 - [Its4landPublicApi.MetricMapFeaturesEndpointType](docs/MetricMapFeaturesEndpointType.md)
 - [Its4landPublicApi.MetricMapFeaturesEndpointTypeFeatures](docs/MetricMapFeaturesEndpointTypeFeatures.md)
 - [Its4landPublicApi.MetricMapFeaturesEndpointTypeGeometry](docs/MetricMapFeaturesEndpointTypeGeometry.md)
 - [Its4landPublicApi.MetricMapFeaturesEndpointTypeProperties](docs/MetricMapFeaturesEndpointTypeProperties.md)
 - [Its4landPublicApi.ModelClassesEndpointType](docs/ModelClassesEndpointType.md)
 - [Its4landPublicApi.ModelClassesEndpointTypeModel](docs/ModelClassesEndpointTypeModel.md)
 - [Its4landPublicApi.ModelClassesPostRequest](docs/ModelClassesPostRequest.md)
 - [Its4landPublicApi.ModelsEndpointType](docs/ModelsEndpointType.md)
 - [Its4landPublicApi.ModelsEndpointTypeModelClasses](docs/ModelsEndpointTypeModelClasses.md)
 - [Its4landPublicApi.ModelsEndpointTypeProjects](docs/ModelsEndpointTypeProjects.md)
 - [Its4landPublicApi.ModelsPatchRequest](docs/ModelsPatchRequest.md)
 - [Its4landPublicApi.ModelsPostRequest](docs/ModelsPostRequest.md)
 - [Its4landPublicApi.ProcessEndpointType](docs/ProcessEndpointType.md)
 - [Its4landPublicApi.ProcessEndpointTypeProject](docs/ProcessEndpointTypeProject.md)
 - [Its4landPublicApi.ProcessEndpointTypeResults](docs/ProcessEndpointTypeResults.md)
 - [Its4landPublicApi.ProcessEndpointTypeTool](docs/ProcessEndpointTypeTool.md)
 - [Its4landPublicApi.ProcessEndpointTypeToolEntryPoint](docs/ProcessEndpointTypeToolEntryPoint.md)
 - [Its4landPublicApi.ProcessEndpointTypeToolEntryPointParameter](docs/ProcessEndpointTypeToolEntryPointParameter.md)
 - [Its4landPublicApi.ProcessPostRequest](docs/ProcessPostRequest.md)
 - [Its4landPublicApi.ProcessPostRequestProject](docs/ProcessPostRequestProject.md)
 - [Its4landPublicApi.ProcessPostRequestTool](docs/ProcessPostRequestTool.md)
 - [Its4landPublicApi.ProcessPostRequestToolEntryPoint](docs/ProcessPostRequestToolEntryPoint.md)
 - [Its4landPublicApi.ProjectsEndpointType](docs/ProjectsEndpointType.md)
 - [Its4landPublicApi.ProjectsEndpointType2](docs/ProjectsEndpointType2.md)
 - [Its4landPublicApi.ProjectsEndpointType2Features](docs/ProjectsEndpointType2Features.md)
 - [Its4landPublicApi.ProjectsEndpointType2Properties](docs/ProjectsEndpointType2Properties.md)
 - [Its4landPublicApi.ProjectsEndpointTypeCrs](docs/ProjectsEndpointTypeCrs.md)
 - [Its4landPublicApi.ProjectsEndpointTypeCrsProperties](docs/ProjectsEndpointTypeCrsProperties.md)
 - [Its4landPublicApi.ProjectsEndpointTypeFeatures](docs/ProjectsEndpointTypeFeatures.md)
 - [Its4landPublicApi.ProjectsEndpointTypeGeometry](docs/ProjectsEndpointTypeGeometry.md)
 - [Its4landPublicApi.ProjectsEndpointTypeProperties](docs/ProjectsEndpointTypeProperties.md)
 - [Its4landPublicApi.ProjectsEndpointTypePropertiesModels](docs/ProjectsEndpointTypePropertiesModels.md)
 - [Its4landPublicApi.ProjectsEndpointTypePropertiesSpatialSources](docs/ProjectsEndpointTypePropertiesSpatialSources.md)
 - [Its4landPublicApi.ProjectsPatchRequest](docs/ProjectsPatchRequest.md)
 - [Its4landPublicApi.ProjectsPostRequest](docs/ProjectsPostRequest.md)
 - [Its4landPublicApi.ProjectsPostRequestFeatures](docs/ProjectsPostRequestFeatures.md)
 - [Its4landPublicApi.ProjectsPostRequestProperties](docs/ProjectsPostRequestProperties.md)
 - [Its4landPublicApi.ProjectsPostRequestPropertiesSpatialSources](docs/ProjectsPostRequestPropertiesSpatialSources.md)
 - [Its4landPublicApi.PublishAndShareConfigEndpointType](docs/PublishAndShareConfigEndpointType.md)
 - [Its4landPublicApi.PublishAndShareConfigEndpointTypeInner](docs/PublishAndShareConfigEndpointTypeInner.md)
 - [Its4landPublicApi.RFC6902PatchRequest](docs/RFC6902PatchRequest.md)
 - [Its4landPublicApi.RFC6902PatchRequestOrg](docs/RFC6902PatchRequestOrg.md)
 - [Its4landPublicApi.RFC6902PatchRequestOrgInner](docs/RFC6902PatchRequestOrgInner.md)
 - [Its4landPublicApi.SiteEndpointType](docs/SiteEndpointType.md)
 - [Its4landPublicApi.SpatialSourcesEndpointType](docs/SpatialSourcesEndpointType.md)
 - [Its4landPublicApi.SpatialSourcesEndpointTypeAdditionalDocuments](docs/SpatialSourcesEndpointTypeAdditionalDocuments.md)
 - [Its4landPublicApi.SpatialSourcesPostRequest](docs/SpatialSourcesPostRequest.md)
 - [Its4landPublicApi.SpatialUnitBaseFeaturePostRequest](docs/SpatialUnitBaseFeaturePostRequest.md)
 - [Its4landPublicApi.SpatialUnitConceptEndpointType](docs/SpatialUnitConceptEndpointType.md)
 - [Its4landPublicApi.SpatialUnitConceptPostRequest](docs/SpatialUnitConceptPostRequest.md)
 - [Its4landPublicApi.SpatialUnitsFeatureEndpointType](docs/SpatialUnitsFeatureEndpointType.md)
 - [Its4landPublicApi.SpatialUnitsFeatureEndpointTypeFeatures](docs/SpatialUnitsFeatureEndpointTypeFeatures.md)
 - [Its4landPublicApi.SpatialUnitsFeatureEndpointTypeProperties](docs/SpatialUnitsFeatureEndpointTypeProperties.md)
 - [Its4landPublicApi.SpatialUnitsFeatureEndpointTypePropertiesAdminSource](docs/SpatialUnitsFeatureEndpointTypePropertiesAdminSource.md)
 - [Its4landPublicApi.SpatialUnitsFeatureEndpointTypePropertiesProjects](docs/SpatialUnitsFeatureEndpointTypePropertiesProjects.md)
 - [Its4landPublicApi.SpatialUnitsFeaturePostRequest](docs/SpatialUnitsFeaturePostRequest.md)
 - [Its4landPublicApi.SpatialUnitsFeaturePostRequestFeatures](docs/SpatialUnitsFeaturePostRequestFeatures.md)
 - [Its4landPublicApi.SpatialUnitsFeaturePostRequestProperties](docs/SpatialUnitsFeaturePostRequestProperties.md)
 - [Its4landPublicApi.TagsEndpointType](docs/TagsEndpointType.md)
 - [Its4landPublicApi.TagsEndpointTypeTaggedObjects](docs/TagsEndpointTypeTaggedObjects.md)
 - [Its4landPublicApi.TagsEndpointTypeTaggedObjectsSum](docs/TagsEndpointTypeTaggedObjectsSum.md)
 - [Its4landPublicApi.TagsListResponse](docs/TagsListResponse.md)
 - [Its4landPublicApi.TagsPostRequest](docs/TagsPostRequest.md)
 - [Its4landPublicApi.ToolsEndpointType](docs/ToolsEndpointType.md)
 - [Its4landPublicApi.ToolsEndpointTypeEntryPoints](docs/ToolsEndpointTypeEntryPoints.md)
 - [Its4landPublicApi.ToolsEndpointTypeImage](docs/ToolsEndpointTypeImage.md)
 - [Its4landPublicApi.TrainingSetsPostRequest](docs/TrainingSetsPostRequest.md)
 - [Its4landPublicApi.TrainingsSetEndpointType](docs/TrainingsSetEndpointType.md)
 - [Its4landPublicApi.TrainingsSetEndpointTypeModels](docs/TrainingsSetEndpointTypeModels.md)
 - [Its4landPublicApi.WP5ValidationSetsEndpointType](docs/WP5ValidationSetsEndpointType.md)
 - [Its4landPublicApi.WP5ValidationSetsPostRequest](docs/WP5ValidationSetsPostRequest.md)


## Documentation for Authorization


### api_key

- **Type**: API key
- **API key parameter name**: X-i4lAPIKEY
- **Location**: HTTP header

