# Its4landPublicApi.AdminSourcesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getAdminSourceByUID**](AdminSourcesApi.md#getAdminSourceByUID) | **GET** /adminsources/{adminsource_uid} | Returns a single Admin Source
[**getAdminSources**](AdminSourcesApi.md#getAdminSources) | **GET** /adminsources | Returns a list of AdminSource document indizes
[**newAdminSource**](AdminSourcesApi.md#newAdminSource) | **POST** /adminsources | Creates a new AdminSource
[**updateAdminSource**](AdminSourcesApi.md#updateAdminSource) | **PATCH** /adminsources/{adminsource_uid} | Update an Admin Source


<a name="getAdminSourceByUID"></a>
# **getAdminSourceByUID**
> AdminSourcesEndpointType getAdminSourceByUID(adminsourceUid, opts, responseAsResult = *false*)

Returns a single Admin Source

Returns a single Admin Source

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.AdminSourcesApi();

var adminsourceUid = "adminsourceUid_example"; // String | AdminSource UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getAdminSourceByUID(adminsourceUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adminsourceUid** | **String**| AdminSource UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getAdminSources"></a>
# **getAdminSources**
> [AdminSourcesEndpointType] getAdminSources(opts, responseAsResult = *false*)

Returns a list of AdminSource document indizes

Returns a list of AdminSource document indizes

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.AdminSourcesApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of AdminSources UID
  'name': ["name_example"], // [String] | Comma separated list of AdminSources names
  'type': ["type_example"], // [String] | Comma separated list of AdminSources types
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'spatialunits': ["spatialunits_example"], // [String] | Comma separated list of SpatialUnit UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of tags
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getAdminSources(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of AdminSources UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of AdminSources names | [optional] 
 **type** | [**[String]**](String.md)| Comma separated list of AdminSources types | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **spatialunits** | [**[String]**](String.md)| Comma separated list of SpatialUnit UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[AdminSourcesEndpointType]**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newAdminSource"></a>
# **newAdminSource**
> AdminSourcesEndpointType newAdminSource(newadminsource, opts, responseAsResult = *false*)

Creates a new AdminSource

Creates a new AdminSource

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.AdminSourcesApi();

var newadminsource = new Its4landPublicApi.AdminSourcesPostRequest(); // AdminSourcesPostRequest | New AdminSource data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newAdminSource(newadminsource, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newadminsource** | [**AdminSourcesPostRequest**](AdminSourcesPostRequest.md)| New AdminSource data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateAdminSource"></a>
# **updateAdminSource**
> AdminSourcesEndpointType updateAdminSource(adminsourceUid, patchadminsource, opts, responseAsResult = *false*)

Update an Admin Source

Update an Admin Source

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.AdminSourcesApi();

var adminsourceUid = "adminsourceUid_example"; // String | AdminSource UID

var patchadminsource = new Its4landPublicApi.RFC6902PatchRequest(); // RFC6902PatchRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateAdminSource(adminsourceUid, patchadminsource, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **adminsourceUid** | **String**| AdminSource UID | 
 **patchadminsource** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**AdminSourcesEndpointType**](AdminSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

