# Its4landPublicApi.BoundaryFaceStringApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getBoundaryFaceString**](BoundaryFaceStringApi.md#getBoundaryFaceString) | **GET** /boundaryfacestring | Returns a list of boundary face strings in a GeoJSON structure.
[**getBoundaryFaceStringByUID**](BoundaryFaceStringApi.md#getBoundaryFaceStringByUID) | **GET** /boundaryfacestring/{boundaryfacestring_uid} | Returns a single boundary face string
[**newBoundaryFaceString**](BoundaryFaceStringApi.md#newBoundaryFaceString) | **POST** /boundaryfacestring | Create a new concept for a boundary face string
[**putBoundaryFaceStringByUID**](BoundaryFaceStringApi.md#putBoundaryFaceStringByUID) | **PUT** /boundaryfacestring/{boundaryfacestring_uid} | Replace an existing BoundaryFaceString by a newer version
[**updateBoundaryFaceString**](BoundaryFaceStringApi.md#updateBoundaryFaceString) | **PATCH** /boundaryfacestring/{boundaryfacestring_uid} | Updates a boundary face string


<a name="getBoundaryFaceString"></a>
# **getBoundaryFaceString**
> BoundaryFaceStringEndpointType getBoundaryFaceString(opts, responseAsResult = *false*)

Returns a list of boundary face strings in a GeoJSON structure.

Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.BoundaryFaceStringApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of Spatial unit UID
  'name': ["name_example"], // [String] | Comma separated list of AdminSources names
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'spatialunit': ["spatialunit_example"], // [String] | Comma separated list of SpatialSource UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of tags
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getBoundaryFaceString(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of Spatial unit UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of AdminSources names | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **spatialunit** | [**[String]**](String.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getBoundaryFaceStringByUID"></a>
# **getBoundaryFaceStringByUID**
> BoundaryFaceStringEndpointType getBoundaryFaceStringByUID(boundaryfacestringUid, opts, responseAsResult = *false*)

Returns a single boundary face string

Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.BoundaryFaceStringApi();

var boundaryfacestringUid = "boundaryfacestringUid_example"; // String | Boundary face string UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getBoundaryFaceStringByUID(boundaryfacestringUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **String**| Boundary face string UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newBoundaryFaceString"></a>
# **newBoundaryFaceString**
> BoundaryFaceStringEndpointType newBoundaryFaceString(newboundaryfacestring, opts, responseAsResult = *false*)

Create a new concept for a boundary face string

Create a new concept for a boundary face string.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.BoundaryFaceStringApi();

var newboundaryfacestring = new Its4landPublicApi.BoundaryFaceStringPostRequest(); // BoundaryFaceStringPostRequest | New boundary face string

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newBoundaryFaceString(newboundaryfacestring, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newboundaryfacestring** | [**BoundaryFaceStringPostRequest**](BoundaryFaceStringPostRequest.md)| New boundary face string | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="putBoundaryFaceStringByUID"></a>
# **putBoundaryFaceStringByUID**
> BoundaryFaceStringEndpointType putBoundaryFaceStringByUID(boundaryfacestringUid, updatedboundaryfacestring, opts, responseAsResult = *false*)

Replace an existing BoundaryFaceString by a newer version

An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.BoundaryFaceStringApi();

var boundaryfacestringUid = "boundaryfacestringUid_example"; // String | Boundary face string UID

var updatedboundaryfacestring = new Its4landPublicApi.BoundaryFaceStringPostRequest(); // BoundaryFaceStringPostRequest | Updated boundary face string

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.putBoundaryFaceStringByUID(boundaryfacestringUid, updatedboundaryfacestring, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **String**| Boundary face string UID | 
 **updatedboundaryfacestring** | [**BoundaryFaceStringPostRequest**](BoundaryFaceStringPostRequest.md)| Updated boundary face string | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateBoundaryFaceString"></a>
# **updateBoundaryFaceString**
> BoundaryFaceStringEndpointType updateBoundaryFaceString(boundaryfacestringUid, patchboundaryfacestring, opts, responseAsResult = *false*)

Updates a boundary face string

Updates a boundary face string

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.BoundaryFaceStringApi();

var boundaryfacestringUid = "boundaryfacestringUid_example"; // String | Boundary face string UID

var patchboundaryfacestring = new Its4landPublicApi.RFC6902PatchRequest(); // RFC6902PatchRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateBoundaryFaceString(boundaryfacestringUid, patchboundaryfacestring, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **boundaryfacestringUid** | **String**| Boundary face string UID | 
 **patchboundaryfacestring** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**BoundaryFaceStringEndpointType**](BoundaryFaceStringEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

