# Its4landPublicApi.ClassifierApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getClassifier**](ClassifierApi.md#getClassifier) | **GET** /classifier | Returns a list of classifier
[**getClassifierByUID**](ClassifierApi.md#getClassifierByUID) | **GET** /classifier/{classifier_id} | Returns a single classifier.
[**newClassifier**](ClassifierApi.md#newClassifier) | **POST** /classifier | Create a new classifier


<a name="getClassifier"></a>
# **getClassifier**
> [ClassifierEndpointType] getClassifier(opts, responseAsResult = *false*)

Returns a list of classifier

Returns a list of classifier

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.ClassifierApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of classifier UID
  'name': ["name_example"], // [String] | Comma separated list of classifier names
  'models': ["models_example"], // [String] | Comma separated list of model UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"] // [String] | Comma separated list of field names
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getClassifier(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of classifier UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of classifier names | [optional] 
 **models** | [**[String]**](String.md)| Comma separated list of model UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of field names | [optional] 


### Return type

[**[ClassifierEndpointType]**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getClassifierByUID"></a>
# **getClassifierByUID**
> ClassifierEndpointType getClassifierByUID(classifierId, opts, responseAsResult = *false*)

Returns a single classifier.

Returns a single classifier.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.ClassifierApi();

var classifierId = "classifierId_example"; // String | Classifier UID

var opts = { 
  'envelope': "envelope_example" // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getClassifierByUID(classifierId, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **classifierId** | **String**| Classifier UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 


### Return type

[**ClassifierEndpointType**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newClassifier"></a>
# **newClassifier**
> ClassifierEndpointType newClassifier(newclassifier, opts, responseAsResult = *false*)

Create a new classifier

Create a new classifier. To add a new Classifier , the content of Classifier must be stored in advanced via the ContentItem endpoint

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.ClassifierApi();

var newclassifier = new Its4landPublicApi.ClassifierPostRequest(); // ClassifierPostRequest | New Classifier data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newClassifier(newclassifier, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newclassifier** | [**ClassifierPostRequest**](ClassifierPostRequest.md)| New Classifier data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**ClassifierEndpointType**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

