# Its4landPublicApi.SpatialUnitsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create2PpolygonSPUfromBFS**](SpatialUnitsApi.md#create2PpolygonSPUfromBFS) | **POST** /spatialunits/create2Dpolygonspatialunit | Creates a spatial unit
[**getSpatialUnitByUID**](SpatialUnitsApi.md#getSpatialUnitByUID) | **GET** /spatialunits/qualitative/{spatialunit_uid} | Returns a single spatial unit
[**getSpatialUnitConceptByUID**](SpatialUnitsApi.md#getSpatialUnitConceptByUID) | **GET** /spatialunits/concepts/{concept_uid} | Returns a single spatial unit concept
[**getSpatialUnits**](SpatialUnitsApi.md#getSpatialUnits) | **GET** /spatialunits | Returns a list of SpatialUnits in a GeoJSON structure.
[**getSpatialUnitsByUUID**](SpatialUnitsApi.md#getSpatialUnitsByUUID) | **GET** /spatialunits/{spatialunit_uid} | Returns a list of SpatialUnits
[**getSpatialUnitsConcepts**](SpatialUnitsApi.md#getSpatialUnitsConcepts) | **GET** /spatialunits/concepts | Returns a list of spatial units concepts
[**getSpatialUnitsQualitative**](SpatialUnitsApi.md#getSpatialUnitsQualitative) | **GET** /spatialunits/qualitative | Returns a list of SpatialUnits
[**newSpatialUnit**](SpatialUnitsApi.md#newSpatialUnit) | **POST** /spatialunits | Create a new SpatialUnit
[**newSpatialUnitConcept**](SpatialUnitsApi.md#newSpatialUnitConcept) | **POST** /spatialunits/concepts | Create a new concept for a spatial unit
[**newSpatialUnitQualitative**](SpatialUnitsApi.md#newSpatialUnitQualitative) | **POST** /spatialunits/qualitative | Create a new SpatialUnit
[**updateSpatialUnit**](SpatialUnitsApi.md#updateSpatialUnit) | **PATCH** /spatialunits/{spatialunit_uid} | Update an spatial unit
[**updateSpatialUnitConcept**](SpatialUnitsApi.md#updateSpatialUnitConcept) | **PATCH** /spatialunits/concepts/{concept_uid} | Updates a new spatial unit concept
[**updateSpatialUnitQualitative**](SpatialUnitsApi.md#updateSpatialUnitQualitative) | **PATCH** /spatialunits/qualitative/{spatialunit_uid} | Updates a new SpatialUnit


<a name="create2PpolygonSPUfromBFS"></a>
# **create2PpolygonSPUfromBFS**
> SpatialUnitsFeatureEndpointType create2PpolygonSPUfromBFS(spatialunitdata, opts, responseAsResult = *false*)

Creates a spatial unit

Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var spatialunitdata = new Its4landPublicApi.SpatialUnitBaseFeaturePostRequest(); // SpatialUnitBaseFeaturePostRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example", // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.create2PpolygonSPUfromBFS(spatialunitdata, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitdata** | [**SpatialUnitBaseFeaturePostRequest**](SpatialUnitBaseFeaturePostRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getSpatialUnitByUID"></a>
# **getSpatialUnitByUID**
> SpatialUnitsFeatureEndpointType getSpatialUnitByUID(spatialunitUid, opts, responseAsResult = *false*)

Returns a single spatial unit

Returns a single spatial unit with qualitative base qualitative base spatial profile

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialUnitByUID(spatialunitUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitConceptByUID"></a>
# **getSpatialUnitConceptByUID**
> SpatialUnitConceptEndpointType getSpatialUnitConceptByUID(conceptUid, opts, responseAsResult = *false*)

Returns a single spatial unit concept

Returns a single spatial unit concept

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var conceptUid = "conceptUid_example"; // String | Spatial unit concept UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialUnitConceptByUID(conceptUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conceptUid** | **String**| Spatial unit concept UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnits"></a>
# **getSpatialUnits**
> [SpatialUnitsFeatureEndpointType] getSpatialUnits(querywindow, opts, responseAsResult = *false*)

Returns a list of SpatialUnits in a GeoJSON structure.

Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var querywindow = "querywindow_example"; // String | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of AdminSources UID
  'name': ["name_example"], // [String] | Comma separated list of AdminSources names
  'concept': ["concept_example"], // [String] | Comma separated list of Spatial Unit concepts
  'level': ["level_example"], // [String] | Comma separated list of LADM Levels
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'adminsource': ["adminsource_example"], // [String] | Comma separated list of SpatialSource UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of tags
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialUnits(querywindow, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **String**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of AdminSources UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of AdminSources names | [optional] 
 **concept** | [**[String]**](String.md)| Comma separated list of Spatial Unit concepts | [optional] 
 **level** | [**[String]**](String.md)| Comma separated list of LADM Levels | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **adminsource** | [**[String]**](String.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[SpatialUnitsFeatureEndpointType]**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitsByUUID"></a>
# **getSpatialUnitsByUUID**
> [SpatialUnitsFeatureEndpointType] getSpatialUnitsByUUID(spatialunitUid, opts, responseAsResult = *false*)

Returns a list of SpatialUnits

Returns a list of SpatialUnits as feature with 2d polygon base spatial profile

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialUnitsByUUID(spatialunitUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[SpatialUnitsFeatureEndpointType]**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitsConcepts"></a>
# **getSpatialUnitsConcepts**
> [SpatialUnitsFeatureEndpointType] getSpatialUnitsConcepts(opts, responseAsResult = *false*)

Returns a list of spatial units concepts

Returns a list of spatial units concepts

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of Spatial unit UID
  'name': ["name_example"], // [String] | Comma separated list of AdminSources names
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'spatialunit': ["spatialunit_example"], // [String] | Comma separated list of SpatialSource UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of tags
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialUnitsConcepts(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of Spatial unit UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of AdminSources names | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **spatialunit** | [**[String]**](String.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[SpatialUnitsFeatureEndpointType]**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialUnitsQualitative"></a>
# **getSpatialUnitsQualitative**
> [SpatialUnitsFeatureEndpointType] getSpatialUnitsQualitative(querywindow, opts, responseAsResult = *false*)

Returns a list of SpatialUnits

Returns a list of SpatialUnits as feature with geometry

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var querywindow = "querywindow_example"; // String | Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of Spatial unit UID
  'name': ["name_example"], // [String] | Comma separated list of AdminSources names
  'concept': ["concept_example"], // [String] | Comma separated list of Spatial Unit concepts
  'level': ["level_example"], // [String] | Comma separated list of LADM Levels
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'adminsource': ["adminsource_example"], // [String] | Comma separated list of SpatialSource UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of tags
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getSpatialUnitsQualitative(querywindow, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **querywindow** | **String**| Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of Spatial unit UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of AdminSources names | [optional] 
 **concept** | [**[String]**](String.md)| Comma separated list of Spatial Unit concepts | [optional] 
 **level** | [**[String]**](String.md)| Comma separated list of LADM Levels | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **adminsource** | [**[String]**](String.md)| Comma separated list of SpatialSource UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[SpatialUnitsFeatureEndpointType]**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newSpatialUnit"></a>
# **newSpatialUnit**
> SpatialUnitsFeatureEndpointType newSpatialUnit(newspatialunit, opts, responseAsResult = *false*)

Create a new SpatialUnit

Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var newspatialunit = new Its4landPublicApi.SpatialUnitsFeaturePostRequest(); // SpatialUnitsFeaturePostRequest | New Spatial Unit data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newSpatialUnit(newspatialunit, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunit** | [**SpatialUnitsFeaturePostRequest**](SpatialUnitsFeaturePostRequest.md)| New Spatial Unit data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newSpatialUnitConcept"></a>
# **newSpatialUnitConcept**
> SpatialUnitConceptEndpointType newSpatialUnitConcept(newspatialunitconcept, opts, responseAsResult = *false*)

Create a new concept for a spatial unit

Create a new concept for a spatial unit.

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var newspatialunitconcept = new Its4landPublicApi.SpatialUnitConceptPostRequest(); // SpatialUnitConceptPostRequest | New Spatial Unit concept data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newSpatialUnitConcept(newspatialunitconcept, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunitconcept** | [**SpatialUnitConceptPostRequest**](SpatialUnitConceptPostRequest.md)| New Spatial Unit concept data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newSpatialUnitQualitative"></a>
# **newSpatialUnitQualitative**
> SpatialUnitsFeatureEndpointType newSpatialUnitQualitative(newspatialunit, opts, responseAsResult = *false*)

Create a new SpatialUnit

Create a new SpatialUnit with qualitative base spatial profile

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var newspatialunit = new Its4landPublicApi.SpatialUnitsFeaturePostRequest(); // SpatialUnitsFeaturePostRequest | New Spatial Unit data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newSpatialUnitQualitative(newspatialunit, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialunit** | [**SpatialUnitsFeaturePostRequest**](SpatialUnitsFeaturePostRequest.md)| New Spatial Unit data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSpatialUnit"></a>
# **updateSpatialUnit**
> SpatialUnitsFeatureEndpointType updateSpatialUnit(spatialunitUid, patchspatialunit, opts, responseAsResult = *false*)

Update an spatial unit

Update an spatial unit with 2d polygon base spatial profile

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID

var patchspatialunit = new Its4landPublicApi.RFC6902PatchRequest(); // RFC6902PatchRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateSpatialUnit(spatialunitUid, patchspatialunit, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID | 
 **patchspatialunit** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSpatialUnitConcept"></a>
# **updateSpatialUnitConcept**
> SpatialUnitConceptEndpointType updateSpatialUnitConcept(conceptUid, patchspatialunitconcept, opts, responseAsResult = *false*)

Updates a new spatial unit concept

Updates a spatial unit concept

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var conceptUid = "conceptUid_example"; // String | Spatial unit concept UID

var patchspatialunitconcept = new Its4landPublicApi.RFC6902PatchRequest(); // RFC6902PatchRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateSpatialUnitConcept(conceptUid, patchspatialunitconcept, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **conceptUid** | **String**| Spatial unit concept UID | 
 **patchspatialunitconcept** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialUnitConceptEndpointType**](SpatialUnitConceptEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateSpatialUnitQualitative"></a>
# **updateSpatialUnitQualitative**
> SpatialUnitsFeatureEndpointType updateSpatialUnitQualitative(spatialunitUid, patchspatialunit, opts, responseAsResult = *false*)

Updates a new SpatialUnit

Updates SpatialUnit with qualitative base spatial profile

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.SpatialUnitsApi();

var spatialunitUid = "spatialunitUid_example"; // String | Spatial unit UID

var patchspatialunit = new Its4landPublicApi.RFC6902PatchRequest(); // RFC6902PatchRequest | Update data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateSpatialUnitQualitative(spatialunitUid, patchspatialunit, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialunitUid** | **String**| Spatial unit UID | 
 **patchspatialunit** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**SpatialUnitsFeatureEndpointType**](SpatialUnitsFeatureEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

