# Its4landPublicApi.WP5ValidationSetsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getWP5ValidationSetByUID**](WP5ValidationSetsApi.md#getWP5ValidationSetByUID) | **GET** /WP5ValidationSets/{wp5validationset_uid} | Returns a single WP5ValidationSet
[**getWP5ValidationSets**](WP5ValidationSetsApi.md#getWP5ValidationSets) | **GET** /WP5ValidationSets | Returns a list of WP5ValidationSets
[**newWP5ValidationSets**](WP5ValidationSetsApi.md#newWP5ValidationSets) | **POST** /WP5ValidationSets | Create a new WP5ValidationSets


<a name="getWP5ValidationSetByUID"></a>
# **getWP5ValidationSetByUID**
> WP5ValidationSetsEndpointType getWP5ValidationSetByUID(wp5validationsetUid, opts, responseAsResult = *false*)

Returns a single WP5ValidationSet

Returns a single WP5ValidationSet

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.WP5ValidationSetsApi();

var wp5validationsetUid = "wp5validationsetUid_example"; // String | WP5ValidationSet UID

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getWP5ValidationSetByUID(wp5validationsetUid, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **wp5validationsetUid** | **String**| WP5ValidationSet UID | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**WP5ValidationSetsEndpointType**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getWP5ValidationSets"></a>
# **getWP5ValidationSets**
> [WP5ValidationSetsEndpointType] getWP5ValidationSets(opts, responseAsResult = *false*)

Returns a list of WP5ValidationSets

Returns a list of WP5ValidationSets

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.WP5ValidationSetsApi();

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'uid': ["uid_example"], // [String] | Comma separated list of TrainingSet UID
  'name': ["name_example"], // [String] | Comma separated list of WP5ValidationSets Names
  'models': ["models_example"], // [String] | Comma separated list of model UID
  'projects': ["projects_example"], // [String] | Comma separated list of project UID
  'tags': ["tags_example"], // [String] | Comma separated list of tags
  'page': 56, // Number | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
  'sort': "sort_example", // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
  'fields': ["fields_example"], // [String] | Comma separated list of field names
  'embed': ["embed_example"] // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getWP5ValidationSets(opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**[String]**](String.md)| Comma separated list of TrainingSet UID | [optional] 
 **name** | [**[String]**](String.md)| Comma separated list of WP5ValidationSets Names | [optional] 
 **models** | [**[String]**](String.md)| Comma separated list of model UID | [optional] 
 **projects** | [**[String]**](String.md)| Comma separated list of project UID | [optional] 
 **tags** | [**[String]**](String.md)| Comma separated list of tags | [optional] 
 **page** | **Number**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**[String]**](String.md)| Comma separated list of field names | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 


### Return type

[**[WP5ValidationSetsEndpointType]**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newWP5ValidationSets"></a>
# **newWP5ValidationSets**
> WP5ValidationSetsEndpointType newWP5ValidationSets(newwp5validationsets, opts, responseAsResult = *false*)

Create a new WP5ValidationSets

Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint

### Example
```javascript
var Its4landPublicApi = require('its4land_public_api');

var apiInstance = new Its4landPublicApi.WP5ValidationSetsApi();

var newwp5validationsets = new Its4landPublicApi.WP5ValidationSetsPostRequest(); // WP5ValidationSetsPostRequest | New WP5ValidationSet data

var opts = { 
  'envelope': "envelope_example", // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
  'embed': ["embed_example"], // [String] | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
  'i4lProcessUid': "i4lProcessUid_example" // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.newWP5ValidationSets(newwp5validationsets, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newwp5validationsets** | [**WP5ValidationSetsPostRequest**](WP5ValidationSetsPostRequest.md)| New WP5ValidationSet data | 
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**[String]**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 


### Return type

[**WP5ValidationSetsEndpointType**](WP5ValidationSetsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

