/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/BoundaryFaceStringEndpointType', 'model/BoundaryFaceStringPostRequest', 'model/RFC6902PatchRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/BoundaryFaceStringEndpointType'), require('../model/BoundaryFaceStringPostRequest'), require('../model/RFC6902PatchRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.BoundaryFaceStringApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.BoundaryFaceStringEndpointType, root.Its4landPublicApi.BoundaryFaceStringPostRequest, root.Its4landPublicApi.RFC6902PatchRequest);
  }
}(this, function(ApiClient, BoundaryFaceStringEndpointType, BoundaryFaceStringPostRequest, RFC6902PatchRequest) {
  'use strict';

  /**
   * BoundaryFaceString service.
   * @module api/BoundaryFaceStringApi
   * @version 0.0.2
   */

  /**
   * Constructs a new BoundaryFaceStringApi. 
   * @alias module:api/BoundaryFaceStringApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getBoundaryFaceString operation.
     * @callback module:api/BoundaryFaceStringApi~getBoundaryFaceStringCallback
     * @param {String} error Error message, if any.
     * @param {module:model/BoundaryFaceStringEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of boundary face strings in a GeoJSON structure.
     * Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of Spatial unit UID
     * @param {Array.<String>} opts.name Comma separated list of AdminSources names
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.spatialunit Comma separated list of SpatialSource UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/BoundaryFaceStringApi~getBoundaryFaceStringCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/BoundaryFaceStringEndpointType}
     */
    this.getBoundaryFaceString = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'spatialunit': {
          value: opts['spatialunit'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = BoundaryFaceStringEndpointType;

      return this.apiClient.callApi(
        '/boundaryfacestring', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getBoundaryFaceStringByUID operation.
     * @callback module:api/BoundaryFaceStringApi~getBoundaryFaceStringByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/BoundaryFaceStringEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single boundary face string
     * Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
     * @param {String} boundaryfacestringUid Boundary face string UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/BoundaryFaceStringApi~getBoundaryFaceStringByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/BoundaryFaceStringEndpointType}
     */
    this.getBoundaryFaceStringByUID = function(boundaryfacestringUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'boundaryfacestringUid' is set
      if (boundaryfacestringUid === undefined || boundaryfacestringUid === null) {
        throw new Error("Missing the required parameter 'boundaryfacestringUid' when calling getBoundaryFaceStringByUID");
      }


      var pathParams = {
        'boundaryfacestring_uid': boundaryfacestringUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = BoundaryFaceStringEndpointType;

      return this.apiClient.callApi(
        '/boundaryfacestring/{boundaryfacestring_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newBoundaryFaceString operation.
     * @callback module:api/BoundaryFaceStringApi~newBoundaryFaceStringCallback
     * @param {String} error Error message, if any.
     * @param {module:model/BoundaryFaceStringEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new concept for a boundary face string
     * Create a new concept for a boundary face string.
     * @param {module:model/BoundaryFaceStringPostRequest} newboundaryfacestring New boundary face string
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/BoundaryFaceStringApi~newBoundaryFaceStringCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/BoundaryFaceStringEndpointType}
     */
    this.newBoundaryFaceString = function(newboundaryfacestring, opts, callback) {
      opts = opts || {};
      var postBody = newboundaryfacestring;

      // verify the required parameter 'newboundaryfacestring' is set
      if (newboundaryfacestring === undefined || newboundaryfacestring === null) {
        throw new Error("Missing the required parameter 'newboundaryfacestring' when calling newBoundaryFaceString");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = BoundaryFaceStringEndpointType;

      return this.apiClient.callApi(
        '/boundaryfacestring', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the putBoundaryFaceStringByUID operation.
     * @callback module:api/BoundaryFaceStringApi~putBoundaryFaceStringByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/BoundaryFaceStringEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace an existing BoundaryFaceString by a newer version
     * An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
     * @param {String} boundaryfacestringUid Boundary face string UID
     * @param {module:model/BoundaryFaceStringPostRequest} updatedboundaryfacestring Updated boundary face string
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/BoundaryFaceStringApi~putBoundaryFaceStringByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/BoundaryFaceStringEndpointType}
     */
    this.putBoundaryFaceStringByUID = function(boundaryfacestringUid, updatedboundaryfacestring, opts, callback) {
      opts = opts || {};
      var postBody = updatedboundaryfacestring;

      // verify the required parameter 'boundaryfacestringUid' is set
      if (boundaryfacestringUid === undefined || boundaryfacestringUid === null) {
        throw new Error("Missing the required parameter 'boundaryfacestringUid' when calling putBoundaryFaceStringByUID");
      }

      // verify the required parameter 'updatedboundaryfacestring' is set
      if (updatedboundaryfacestring === undefined || updatedboundaryfacestring === null) {
        throw new Error("Missing the required parameter 'updatedboundaryfacestring' when calling putBoundaryFaceStringByUID");
      }


      var pathParams = {
        'boundaryfacestring_uid': boundaryfacestringUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = BoundaryFaceStringEndpointType;

      return this.apiClient.callApi(
        '/boundaryfacestring/{boundaryfacestring_uid}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateBoundaryFaceString operation.
     * @callback module:api/BoundaryFaceStringApi~updateBoundaryFaceStringCallback
     * @param {String} error Error message, if any.
     * @param {module:model/BoundaryFaceStringEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates a boundary face string
     * Updates a boundary face string
     * @param {String} boundaryfacestringUid Boundary face string UID
     * @param {module:model/RFC6902PatchRequest} patchboundaryfacestring Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/BoundaryFaceStringApi~updateBoundaryFaceStringCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/BoundaryFaceStringEndpointType}
     */
    this.updateBoundaryFaceString = function(boundaryfacestringUid, patchboundaryfacestring, opts, callback) {
      opts = opts || {};
      var postBody = patchboundaryfacestring;

      // verify the required parameter 'boundaryfacestringUid' is set
      if (boundaryfacestringUid === undefined || boundaryfacestringUid === null) {
        throw new Error("Missing the required parameter 'boundaryfacestringUid' when calling updateBoundaryFaceString");
      }

      // verify the required parameter 'patchboundaryfacestring' is set
      if (patchboundaryfacestring === undefined || patchboundaryfacestring === null) {
        throw new Error("Missing the required parameter 'patchboundaryfacestring' when calling updateBoundaryFaceString");
      }


      var pathParams = {
        'boundaryfacestring_uid': boundaryfacestringUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = BoundaryFaceStringEndpointType;

      return this.apiClient.callApi(
        '/boundaryfacestring/{boundaryfacestring_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
