/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ClassifierEndpointType', 'model/ClassifierPostRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ClassifierEndpointType'), require('../model/ClassifierPostRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ClassifierApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ClassifierEndpointType, root.Its4landPublicApi.ClassifierPostRequest);
  }
}(this, function(ApiClient, ClassifierEndpointType, ClassifierPostRequest) {
  'use strict';

  /**
   * Classifier service.
   * @module api/ClassifierApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ClassifierApi. 
   * @alias module:api/ClassifierApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getClassifier operation.
     * @callback module:api/ClassifierApi~getClassifierCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ClassifierEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of classifier
     * Returns a list of classifier
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of classifier UID
     * @param {Array.<String>} opts.name Comma separated list of classifier names
     * @param {Array.<String>} opts.models Comma separated list of model UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {module:api/ClassifierApi~getClassifierCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ClassifierEndpointType>}
     */
    this.getClassifier = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'models': {
          value: opts['models'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ClassifierEndpointType];

      return this.apiClient.callApi(
        '/classifier', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getClassifierByUID operation.
     * @callback module:api/ClassifierApi~getClassifierByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ClassifierEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single classifier.
     * Returns a single classifier.
     * @param {String} classifierId Classifier UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {module:api/ClassifierApi~getClassifierByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ClassifierEndpointType}
     */
    this.getClassifierByUID = function(classifierId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'classifierId' is set
      if (classifierId === undefined || classifierId === null) {
        throw new Error("Missing the required parameter 'classifierId' when calling getClassifierByUID");
      }


      var pathParams = {
        'classifier_id': classifierId
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = ClassifierEndpointType;

      return this.apiClient.callApi(
        '/classifier/{classifier_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newClassifier operation.
     * @callback module:api/ClassifierApi~newClassifierCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ClassifierEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new classifier
     * Create a new classifier. To add a new Classifier , the content of Classifier must be stored in advanced via the ContentItem endpoint
     * @param {module:model/ClassifierPostRequest} newclassifier New Classifier data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ClassifierApi~newClassifierCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ClassifierEndpointType}
     */
    this.newClassifier = function(newclassifier, opts, callback) {
      opts = opts || {};
      var postBody = newclassifier;

      // verify the required parameter 'newclassifier' is set
      if (newclassifier === undefined || newclassifier === null) {
        throw new Error("Missing the required parameter 'newclassifier' when calling newClassifier");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = ClassifierEndpointType;

      return this.apiClient.callApi(
        '/classifier', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
