/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ContentItemEndpointType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ContentItemEndpointType'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ContentItemsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ContentItemEndpointType);
  }
}(this, function(ApiClient, ContentItemEndpointType) {
  'use strict';

  /**
   * ContentItems service.
   * @module api/ContentItemsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ContentItemsApi. 
   * @alias module:api/ContentItemsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getContentItem operation.
     * @callback module:api/ContentItemsApi~getContentItemCallback
     * @param {String} error Error message, if any.
     * @param {File} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single content from the object storage.
     * Returns a single content from the object storage.
     * @param {String} contentitemId UID of the ContentItem
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {module:api/ContentItemsApi~getContentItemCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link File}
     */
    this.getContentItem = function(contentitemId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'contentitemId' is set
      if (contentitemId === undefined || contentitemId === null) {
        throw new Error("Missing the required parameter 'contentitemId' when calling getContentItem");
      }


      var pathParams = {
        'contentitem_id': contentitemId
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['multipart/form-data'];
      var returnType = File;

      return this.apiClient.callApi(
        '/contentitems/{contentitem_id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getContentItems operation.
     * @callback module:api/ContentItemsApi~getContentItemsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ContentItemEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of contentitems
     * Returns a list of contentitem metadata based on the filter criteria
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid UID of a ContentItem
     * @param {Array.<String>} opts.contentname Name of File
     * @param {Array.<String>} opts.contenttype mime/type of the content
     * @param {String} opts.contentdescription Free text for description. Only plain text.
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ContentItemsApi~getContentItemsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ContentItemEndpointType>}
     */
    this.getContentItems = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'contentdescription': opts['contentdescription'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'contentname': {
          value: opts['contentname'],
          collectionFormat: 'csv'
        },
        'contenttype': {
          value: opts['contenttype'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ContentItemEndpointType];

      return this.apiClient.callApi(
        '/contentitems', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newContentItem operation.
     * @callback module:api/ContentItemsApi~newContentItemCallback
     * @param {String} error Error message, if any.
     * @param {module:model/ContentItemEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new content in the object storage
     * Create a new content in the object storage
     * @param {File} newcontent Content as multipart from-data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.description Description of content (optional)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/ContentItemsApi~newContentItemCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/ContentItemEndpointType}
     */
    this.newContentItem = function(newcontent, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'newcontent' is set
      if (newcontent === undefined || newcontent === null) {
        throw new Error("Missing the required parameter 'newcontent' when calling newContentItem");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
        'newcontent': newcontent,
        'description': opts['description']
      };

      var authNames = [];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json'];
      var returnType = ContentItemEndpointType;

      return this.apiClient.callApi(
        '/contentitems', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
