/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MetricMapFeaturePostRequest', 'model/MetricMapFeaturesEndpointType', 'model/RFC6902PatchRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/MetricMapFeaturePostRequest'), require('../model/MetricMapFeaturesEndpointType'), require('../model/RFC6902PatchRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.MetricMapFeaturesApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.MetricMapFeaturePostRequest, root.Its4landPublicApi.MetricMapFeaturesEndpointType, root.Its4landPublicApi.RFC6902PatchRequest);
  }
}(this, function(ApiClient, MetricMapFeaturePostRequest, MetricMapFeaturesEndpointType, RFC6902PatchRequest) {
  'use strict';

  /**
   * MetricMapFeatures service.
   * @module api/MetricMapFeaturesApi
   * @version 0.0.2
   */

  /**
   * Constructs a new MetricMapFeaturesApi. 
   * @alias module:api/MetricMapFeaturesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getMetricMapFeature operation.
     * @callback module:api/MetricMapFeaturesApi~getMetricMapFeatureCallback
     * @param {String} error Error message, if any.
     * @param {module:model/MetricMapFeaturesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns MetricMapFeature
     * Returns MetricMapFeature in a GeoJSON structure. A metric map feature is modeled as a feature in  the GeoJSON structure.
     * @param {String} querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.fgroup Restricts the output to the listed feature group
     * @param {String} opts.ftype Restricts the output to the listed feature types. When used in combination with fgroup, output contains only those ftype which are contained in the feature groups
     * @param {String} opts.fsubtype Restricts the output to the listed feature types. When used in combination with fgroup and/or ftype, output contains only those fsubtype which are contained in the feature groups and feature types
     * @param {module:api/MetricMapFeaturesApi~getMetricMapFeatureCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/MetricMapFeaturesEndpointType}
     */
    this.getMetricMapFeature = function(querywindow, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'querywindow' is set
      if (querywindow === undefined || querywindow === null) {
        throw new Error("Missing the required parameter 'querywindow' when calling getMetricMapFeature");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'querywindow': querywindow,
        'fgroup': opts['fgroup'],
        'ftype': opts['ftype'],
        'fsubtype': opts['fsubtype'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = MetricMapFeaturesEndpointType;

      return this.apiClient.callApi(
        '/metricmapfeature', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newMetricMapFeature operation.
     * @callback module:api/MetricMapFeaturesApi~newMetricMapFeatureCallback
     * @param {String} error Error message, if any.
     * @param {module:model/MetricMapFeaturesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new metricMapFeature
     * Create a new MetricMapFeature. The new metric map feature is a feature in the GeoJSON structure. Currently ony one new feature per request is allowed.
     * @param {module:model/MetricMapFeaturePostRequest} newmetricmapfeature New MetricMap Feature data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/MetricMapFeaturesApi~newMetricMapFeatureCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/MetricMapFeaturesEndpointType}
     */
    this.newMetricMapFeature = function(newmetricmapfeature, opts, callback) {
      opts = opts || {};
      var postBody = newmetricmapfeature;

      // verify the required parameter 'newmetricmapfeature' is set
      if (newmetricmapfeature === undefined || newmetricmapfeature === null) {
        throw new Error("Missing the required parameter 'newmetricmapfeature' when calling newMetricMapFeature");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = MetricMapFeaturesEndpointType;

      return this.apiClient.callApi(
        '/metricmapfeature', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateMetricMapFeature operation.
     * @callback module:api/MetricMapFeaturesApi~updateMetricMapFeatureCallback
     * @param {String} error Error message, if any.
     * @param {module:model/MetricMapFeaturesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates a metric map feature
     * Updates a metric map feature. Only fgroup, fname, ftype, fsubtype and fURI can be updated
     * @param {String} mmfUid MetricMapFeature UID
     * @param {module:model/RFC6902PatchRequest} patchmetricmapfeature Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/MetricMapFeaturesApi~updateMetricMapFeatureCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/MetricMapFeaturesEndpointType}
     */
    this.updateMetricMapFeature = function(mmfUid, patchmetricmapfeature, opts, callback) {
      opts = opts || {};
      var postBody = patchmetricmapfeature;

      // verify the required parameter 'mmfUid' is set
      if (mmfUid === undefined || mmfUid === null) {
        throw new Error("Missing the required parameter 'mmfUid' when calling updateMetricMapFeature");
      }

      // verify the required parameter 'patchmetricmapfeature' is set
      if (patchmetricmapfeature === undefined || patchmetricmapfeature === null) {
        throw new Error("Missing the required parameter 'patchmetricmapfeature' when calling updateMetricMapFeature");
      }


      var pathParams = {
        'mmf_uid': mmfUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = MetricMapFeaturesEndpointType;

      return this.apiClient.callApi(
        '/metricmapfeature/{mmf_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
