/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/DDILayersEndpointType', 'model/DDILayersPostRequest', 'model/PublishAndShareConfigEndpointType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/DDILayersEndpointType'), require('../model/DDILayersPostRequest'), require('../model/PublishAndShareConfigEndpointType'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.MiscApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.DDILayersEndpointType, root.Its4landPublicApi.DDILayersPostRequest, root.Its4landPublicApi.PublishAndShareConfigEndpointType);
  }
}(this, function(ApiClient, DDILayersEndpointType, DDILayersPostRequest, PublishAndShareConfigEndpointType) {
  'use strict';

  /**
   * Misc service.
   * @module api/MiscApi
   * @version 0.0.2
   */

  /**
   * Constructs a new MiscApi. 
   * @alias module:api/MiscApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getDDILayers operation.
     * @callback module:api/MiscApi~getDDILayersCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/DDILayersEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Return a list of registered DDI (WFS/WMS) Layer
     * Return a list of registered DDI (WFS/WMS) Layer
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of TrainingSet UID
     * @param {Array.<String>} opts.name Comma separated list of WP5ValidationSets Names
     * @param {Array.<String>} opts.type Comma separated list OGC types
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/MiscApi~getDDILayersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/DDILayersEndpointType>}
     */
    this.getDDILayers = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'type': {
          value: opts['type'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [DDILayersEndpointType];

      return this.apiClient.callApi(
        '/DDILayers', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getPuSConfig operation.
     * @callback module:api/MiscApi~getPuSConfigCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/PublishAndShareConfigEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of configuration parameters as Key Value
     * Returns a list of configuration parameters as Key Value. E.g. URL of the DDI server
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/MiscApi~getPuSConfigCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/PublishAndShareConfigEndpointType>}
     */
    this.getPuSConfig = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [PublishAndShareConfigEndpointType];

      return this.apiClient.callApi(
        '/PuSConfig', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newDDILayers operation.
     * @callback module:api/MiscApi~newDDILayersCallback
     * @param {String} error Error message, if any.
     * @param {module:model/DDILayersEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Register a new DDI (WFS/WMS) Layer
     * Register DDI (WFS/WMS) Layer
     * @param {module:model/DDILayersPostRequest} newDDILayer New image metadata
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/MiscApi~newDDILayersCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/DDILayersEndpointType}
     */
    this.newDDILayers = function(newDDILayer, opts, callback) {
      opts = opts || {};
      var postBody = newDDILayer;

      // verify the required parameter 'newDDILayer' is set
      if (newDDILayer === undefined || newDDILayer === null) {
        throw new Error("Missing the required parameter 'newDDILayer' when calling newDDILayers");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = DDILayersEndpointType;

      return this.apiClient.callApi(
        '/DDILayers', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
