/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AdditionalDocumentsEndpointType', 'model/AdditionalDocumentsPost', 'model/SpatialSourcesEndpointType', 'model/SpatialSourcesPostRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/AdditionalDocumentsEndpointType'), require('../model/AdditionalDocumentsPost'), require('../model/SpatialSourcesEndpointType'), require('../model/SpatialSourcesPostRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.SpatialSourcesApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.AdditionalDocumentsEndpointType, root.Its4landPublicApi.AdditionalDocumentsPost, root.Its4landPublicApi.SpatialSourcesEndpointType, root.Its4landPublicApi.SpatialSourcesPostRequest);
  }
}(this, function(ApiClient, AdditionalDocumentsEndpointType, AdditionalDocumentsPost, SpatialSourcesEndpointType, SpatialSourcesPostRequest) {
  'use strict';

  /**
   * SpatialSources service.
   * @module api/SpatialSourcesApi
   * @version 0.0.2
   */

  /**
   * Constructs a new SpatialSourcesApi. 
   * @alias module:api/SpatialSourcesApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the detachSpatialSourceAddDoc operation.
     * @callback module:api/SpatialSourcesApi~detachSpatialSourceAddDocCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialSourcesEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Removes an additional document for a spatial source.
     * Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {String} adddocUid SpatialSource UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.forceDelete Deletes the additional document resource.
     * @param {module:api/SpatialSourcesApi~detachSpatialSourceAddDocCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialSourcesEndpointType>}
     */
    this.detachSpatialSourceAddDoc = function(spatialsourceUid, adddocUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling detachSpatialSourceAddDoc");
      }

      // verify the required parameter 'adddocUid' is set
      if (adddocUid === undefined || adddocUid === null) {
        throw new Error("Missing the required parameter 'adddocUid' when calling detachSpatialSourceAddDoc");
      }


      var pathParams = {
        'spatialsource_uid': spatialsourceUid,
        'adddoc_uid': adddocUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'force_delete': opts['forceDelete'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialSourcesEndpointType];

      return this.apiClient.callApi(
        '/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialSourceAddDocs operation.
     * @callback module:api/SpatialSourcesApi~getSpatialSourceAddDocsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/AdditionalDocumentsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns the additional documents of a spatial source
     * Returns the additional documents of a spatial source
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {module:api/SpatialSourcesApi~getSpatialSourceAddDocsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/AdditionalDocumentsEndpointType>}
     */
    this.getSpatialSourceAddDocs = function(spatialsourceUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling getSpatialSourceAddDocs");
      }


      var pathParams = {
        'spatialsource_uid': spatialsourceUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [AdditionalDocumentsEndpointType];

      return this.apiClient.callApi(
        '/spatialsource/{spatialsource_uid}/AdditionalDocument', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialSourceByUID operation.
     * @callback module:api/SpatialSourcesApi~getSpatialSourceByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialSourcesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single SpatialSource
     * Returns a single SpatialSource
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialSourcesApi~getSpatialSourceByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialSourcesEndpointType}
     */
    this.getSpatialSourceByUID = function(spatialsourceUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling getSpatialSourceByUID");
      }


      var pathParams = {
        'spatialsource_uid': spatialsourceUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = SpatialSourcesEndpointType;

      return this.apiClient.callApi(
        '/spatialsource/{spatialsource_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialSourceSingleAddDoc operation.
     * @callback module:api/SpatialSourcesApi~getSpatialSourceSingleAddDocCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/AdditionalDocumentsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns the additional documents of a spatial source
     * Returns the additional documents of a spatial source
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {String} adddocUid SpatialSource UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {module:api/SpatialSourcesApi~getSpatialSourceSingleAddDocCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/AdditionalDocumentsEndpointType>}
     */
    this.getSpatialSourceSingleAddDoc = function(spatialsourceUid, adddocUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling getSpatialSourceSingleAddDoc");
      }

      // verify the required parameter 'adddocUid' is set
      if (adddocUid === undefined || adddocUid === null) {
        throw new Error("Missing the required parameter 'adddocUid' when calling getSpatialSourceSingleAddDoc");
      }


      var pathParams = {
        'spatialsource_uid': spatialsourceUid,
        'adddoc_uid': adddocUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [AdditionalDocumentsEndpointType];

      return this.apiClient.callApi(
        '/spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialSources operation.
     * @callback module:api/SpatialSourcesApi~getSpatialSourcesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialSourcesEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of SpatialSources
     * Returns a list of SpatialSources
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of SpatialSources UID
     * @param {Array.<String>} opts.name Comma separated list of SpatialSources names
     * @param {Array.<String>} opts.type Comma separated list of SpatialSources types
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialSourcesApi~getSpatialSourcesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialSourcesEndpointType>}
     */
    this.getSpatialSources = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'type': {
          value: opts['type'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialSourcesEndpointType];

      return this.apiClient.callApi(
        '/spatialsources', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newSpatialSource operation.
     * @callback module:api/SpatialSourcesApi~newSpatialSourceCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialSourcesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new SpatialSource
     * Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.
     * @param {module:model/SpatialSourcesPostRequest} newspatialsource New SpatialSource data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.processUid deprecated
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialSourcesApi~newSpatialSourceCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialSourcesEndpointType}
     */
    this.newSpatialSource = function(newspatialsource, opts, callback) {
      opts = opts || {};
      var postBody = newspatialsource;

      // verify the required parameter 'newspatialsource' is set
      if (newspatialsource === undefined || newspatialsource === null) {
        throw new Error("Missing the required parameter 'newspatialsource' when calling newSpatialSource");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'process_uid': opts['processUid'],
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialSourcesEndpointType;

      return this.apiClient.callApi(
        '/spatialsources', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newSpatialSourceAddAddDoc operation.
     * @callback module:api/SpatialSourcesApi~newSpatialSourceAddAddDocCallback
     * @param {String} error Error message, if any.
     * @param {module:model/AdditionalDocumentsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Add a new additional document to a spatial source
     * Add a new additional document to a spatial source
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {module:model/AdditionalDocumentsPost} newadddocdata New additional document data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialSourcesApi~newSpatialSourceAddAddDocCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/AdditionalDocumentsEndpointType}
     */
    this.newSpatialSourceAddAddDoc = function(spatialsourceUid, newadddocdata, opts, callback) {
      opts = opts || {};
      var postBody = newadddocdata;

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling newSpatialSourceAddAddDoc");
      }

      // verify the required parameter 'newadddocdata' is set
      if (newadddocdata === undefined || newadddocdata === null) {
        throw new Error("Missing the required parameter 'newadddocdata' when calling newSpatialSourceAddAddDoc");
      }


      var pathParams = {
        'spatialsource_uid': spatialsourceUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = AdditionalDocumentsEndpointType;

      return this.apiClient.callApi(
        '/spatialsource/{spatialsource_uid}/AdditionalDocument', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the putSpatialSourceByUID operation.
     * @callback module:api/SpatialSourcesApi~putSpatialSourceByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialSourcesEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Replace an existing SpatialSource by a newer version
     * An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains
     * @param {String} spatialsourceUid SpatialSource UID
     * @param {module:model/SpatialSourcesPostRequest} updatedspatialsource Updated spatial source
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialSourcesApi~putSpatialSourceByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialSourcesEndpointType}
     */
    this.putSpatialSourceByUID = function(spatialsourceUid, updatedspatialsource, opts, callback) {
      opts = opts || {};
      var postBody = updatedspatialsource;

      // verify the required parameter 'spatialsourceUid' is set
      if (spatialsourceUid === undefined || spatialsourceUid === null) {
        throw new Error("Missing the required parameter 'spatialsourceUid' when calling putSpatialSourceByUID");
      }

      // verify the required parameter 'updatedspatialsource' is set
      if (updatedspatialsource === undefined || updatedspatialsource === null) {
        throw new Error("Missing the required parameter 'updatedspatialsource' when calling putSpatialSourceByUID");
      }


      var pathParams = {
        'spatialsource_uid': spatialsourceUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = SpatialSourcesEndpointType;

      return this.apiClient.callApi(
        '/spatialsource/{spatialsource_uid}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
