/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RFC6902PatchRequest', 'model/SpatialUnitBaseFeaturePostRequest', 'model/SpatialUnitConceptEndpointType', 'model/SpatialUnitConceptPostRequest', 'model/SpatialUnitsFeatureEndpointType', 'model/SpatialUnitsFeaturePostRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/RFC6902PatchRequest'), require('../model/SpatialUnitBaseFeaturePostRequest'), require('../model/SpatialUnitConceptEndpointType'), require('../model/SpatialUnitConceptPostRequest'), require('../model/SpatialUnitsFeatureEndpointType'), require('../model/SpatialUnitsFeaturePostRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.SpatialUnitsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.RFC6902PatchRequest, root.Its4landPublicApi.SpatialUnitBaseFeaturePostRequest, root.Its4landPublicApi.SpatialUnitConceptEndpointType, root.Its4landPublicApi.SpatialUnitConceptPostRequest, root.Its4landPublicApi.SpatialUnitsFeatureEndpointType, root.Its4landPublicApi.SpatialUnitsFeaturePostRequest);
  }
}(this, function(ApiClient, RFC6902PatchRequest, SpatialUnitBaseFeaturePostRequest, SpatialUnitConceptEndpointType, SpatialUnitConceptPostRequest, SpatialUnitsFeatureEndpointType, SpatialUnitsFeaturePostRequest) {
  'use strict';

  /**
   * SpatialUnits service.
   * @module api/SpatialUnitsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new SpatialUnitsApi. 
   * @alias module:api/SpatialUnitsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the create2PpolygonSPUfromBFS operation.
     * @callback module:api/SpatialUnitsApi~create2PpolygonSPUfromBFSCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitsFeatureEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Creates a spatial unit
     * Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
     * @param {module:model/SpatialUnitBaseFeaturePostRequest} spatialunitdata Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~create2PpolygonSPUfromBFSCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitsFeatureEndpointType}
     */
    this.create2PpolygonSPUfromBFS = function(spatialunitdata, opts, callback) {
      opts = opts || {};
      var postBody = spatialunitdata;

      // verify the required parameter 'spatialunitdata' is set
      if (spatialunitdata === undefined || spatialunitdata === null) {
        throw new Error("Missing the required parameter 'spatialunitdata' when calling create2PpolygonSPUfromBFS");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitsFeatureEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/create2Dpolygonspatialunit', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialUnitByUID operation.
     * @callback module:api/SpatialUnitsApi~getSpatialUnitByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitsFeatureEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single spatial unit
     * Returns a single spatial unit with qualitative base qualitative base spatial profile
     * @param {String} spatialunitUid Spatial unit UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~getSpatialUnitByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitsFeatureEndpointType}
     */
    this.getSpatialUnitByUID = function(spatialunitUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'spatialunitUid' is set
      if (spatialunitUid === undefined || spatialunitUid === null) {
        throw new Error("Missing the required parameter 'spatialunitUid' when calling getSpatialUnitByUID");
      }


      var pathParams = {
        'spatialunit_uid': spatialunitUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = SpatialUnitsFeatureEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/qualitative/{spatialunit_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialUnitConceptByUID operation.
     * @callback module:api/SpatialUnitsApi~getSpatialUnitConceptByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitConceptEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single spatial unit concept
     * Returns a single spatial unit concept
     * @param {String} conceptUid Spatial unit concept UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~getSpatialUnitConceptByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitConceptEndpointType}
     */
    this.getSpatialUnitConceptByUID = function(conceptUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'conceptUid' is set
      if (conceptUid === undefined || conceptUid === null) {
        throw new Error("Missing the required parameter 'conceptUid' when calling getSpatialUnitConceptByUID");
      }


      var pathParams = {
        'concept_uid': conceptUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = SpatialUnitConceptEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/concepts/{concept_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialUnits operation.
     * @callback module:api/SpatialUnitsApi~getSpatialUnitsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialUnitsFeatureEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of SpatialUnits in a GeoJSON structure.
     * Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
     * @param {String} querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of AdminSources UID
     * @param {Array.<String>} opts.name Comma separated list of AdminSources names
     * @param {Array.<String>} opts.concept Comma separated list of Spatial Unit concepts
     * @param {Array.<String>} opts.level Comma separated list of LADM Levels
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.adminsource Comma separated list of SpatialSource UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~getSpatialUnitsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialUnitsFeatureEndpointType>}
     */
    this.getSpatialUnits = function(querywindow, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'querywindow' is set
      if (querywindow === undefined || querywindow === null) {
        throw new Error("Missing the required parameter 'querywindow' when calling getSpatialUnits");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'querywindow': querywindow,
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'concept': {
          value: opts['concept'],
          collectionFormat: 'csv'
        },
        'level': {
          value: opts['level'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'adminsource': {
          value: opts['adminsource'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialUnitsFeatureEndpointType];

      return this.apiClient.callApi(
        '/spatialunits', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialUnitsByUUID operation.
     * @callback module:api/SpatialUnitsApi~getSpatialUnitsByUUIDCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialUnitsFeatureEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of SpatialUnits
     * Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
     * @param {String} spatialunitUid Spatial unit UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~getSpatialUnitsByUUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialUnitsFeatureEndpointType>}
     */
    this.getSpatialUnitsByUUID = function(spatialunitUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'spatialunitUid' is set
      if (spatialunitUid === undefined || spatialunitUid === null) {
        throw new Error("Missing the required parameter 'spatialunitUid' when calling getSpatialUnitsByUUID");
      }


      var pathParams = {
        'spatialunit_uid': spatialunitUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialUnitsFeatureEndpointType];

      return this.apiClient.callApi(
        '/spatialunits/{spatialunit_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialUnitsConcepts operation.
     * @callback module:api/SpatialUnitsApi~getSpatialUnitsConceptsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialUnitsFeatureEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of spatial units concepts
     * Returns a list of spatial units concepts
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of Spatial unit UID
     * @param {Array.<String>} opts.name Comma separated list of AdminSources names
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.spatialunit Comma separated list of SpatialSource UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~getSpatialUnitsConceptsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialUnitsFeatureEndpointType>}
     */
    this.getSpatialUnitsConcepts = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'spatialunit': {
          value: opts['spatialunit'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialUnitsFeatureEndpointType];

      return this.apiClient.callApi(
        '/spatialunits/concepts', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getSpatialUnitsQualitative operation.
     * @callback module:api/SpatialUnitsApi~getSpatialUnitsQualitativeCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SpatialUnitsFeatureEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of SpatialUnits
     * Returns a list of SpatialUnits as feature with geometry
     * @param {String} querywindow Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of Spatial unit UID
     * @param {Array.<String>} opts.name Comma separated list of AdminSources names
     * @param {Array.<String>} opts.concept Comma separated list of Spatial Unit concepts
     * @param {Array.<String>} opts.level Comma separated list of LADM Levels
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.adminsource Comma separated list of SpatialSource UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/SpatialUnitsApi~getSpatialUnitsQualitativeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SpatialUnitsFeatureEndpointType>}
     */
    this.getSpatialUnitsQualitative = function(querywindow, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'querywindow' is set
      if (querywindow === undefined || querywindow === null) {
        throw new Error("Missing the required parameter 'querywindow' when calling getSpatialUnitsQualitative");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'querywindow': querywindow,
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'concept': {
          value: opts['concept'],
          collectionFormat: 'csv'
        },
        'level': {
          value: opts['level'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'adminsource': {
          value: opts['adminsource'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SpatialUnitsFeatureEndpointType];

      return this.apiClient.callApi(
        '/spatialunits/qualitative', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newSpatialUnit operation.
     * @callback module:api/SpatialUnitsApi~newSpatialUnitCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitsFeatureEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new SpatialUnit
     * Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
     * @param {module:model/SpatialUnitsFeaturePostRequest} newspatialunit New Spatial Unit data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialUnitsApi~newSpatialUnitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitsFeatureEndpointType}
     */
    this.newSpatialUnit = function(newspatialunit, opts, callback) {
      opts = opts || {};
      var postBody = newspatialunit;

      // verify the required parameter 'newspatialunit' is set
      if (newspatialunit === undefined || newspatialunit === null) {
        throw new Error("Missing the required parameter 'newspatialunit' when calling newSpatialUnit");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitsFeatureEndpointType;

      return this.apiClient.callApi(
        '/spatialunits', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newSpatialUnitConcept operation.
     * @callback module:api/SpatialUnitsApi~newSpatialUnitConceptCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitConceptEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new concept for a spatial unit
     * Create a new concept for a spatial unit.
     * @param {module:model/SpatialUnitConceptPostRequest} newspatialunitconcept New Spatial Unit concept data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialUnitsApi~newSpatialUnitConceptCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitConceptEndpointType}
     */
    this.newSpatialUnitConcept = function(newspatialunitconcept, opts, callback) {
      opts = opts || {};
      var postBody = newspatialunitconcept;

      // verify the required parameter 'newspatialunitconcept' is set
      if (newspatialunitconcept === undefined || newspatialunitconcept === null) {
        throw new Error("Missing the required parameter 'newspatialunitconcept' when calling newSpatialUnitConcept");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitConceptEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/concepts', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newSpatialUnitQualitative operation.
     * @callback module:api/SpatialUnitsApi~newSpatialUnitQualitativeCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitsFeatureEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new SpatialUnit
     * Create a new SpatialUnit with qualitative base spatial profile
     * @param {module:model/SpatialUnitsFeaturePostRequest} newspatialunit New Spatial Unit data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialUnitsApi~newSpatialUnitQualitativeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitsFeatureEndpointType}
     */
    this.newSpatialUnitQualitative = function(newspatialunit, opts, callback) {
      opts = opts || {};
      var postBody = newspatialunit;

      // verify the required parameter 'newspatialunit' is set
      if (newspatialunit === undefined || newspatialunit === null) {
        throw new Error("Missing the required parameter 'newspatialunit' when calling newSpatialUnitQualitative");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitsFeatureEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/qualitative', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateSpatialUnit operation.
     * @callback module:api/SpatialUnitsApi~updateSpatialUnitCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitsFeatureEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an spatial unit
     * Update an spatial unit with 2d polygon base spatial profile
     * @param {String} spatialunitUid Spatial unit UID
     * @param {module:model/RFC6902PatchRequest} patchspatialunit Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialUnitsApi~updateSpatialUnitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitsFeatureEndpointType}
     */
    this.updateSpatialUnit = function(spatialunitUid, patchspatialunit, opts, callback) {
      opts = opts || {};
      var postBody = patchspatialunit;

      // verify the required parameter 'spatialunitUid' is set
      if (spatialunitUid === undefined || spatialunitUid === null) {
        throw new Error("Missing the required parameter 'spatialunitUid' when calling updateSpatialUnit");
      }

      // verify the required parameter 'patchspatialunit' is set
      if (patchspatialunit === undefined || patchspatialunit === null) {
        throw new Error("Missing the required parameter 'patchspatialunit' when calling updateSpatialUnit");
      }


      var pathParams = {
        'spatialunit_uid': spatialunitUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitsFeatureEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/{spatialunit_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateSpatialUnitConcept operation.
     * @callback module:api/SpatialUnitsApi~updateSpatialUnitConceptCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitConceptEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates a new spatial unit concept
     * Updates a spatial unit concept
     * @param {String} conceptUid Spatial unit concept UID
     * @param {module:model/RFC6902PatchRequest} patchspatialunitconcept Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialUnitsApi~updateSpatialUnitConceptCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitConceptEndpointType}
     */
    this.updateSpatialUnitConcept = function(conceptUid, patchspatialunitconcept, opts, callback) {
      opts = opts || {};
      var postBody = patchspatialunitconcept;

      // verify the required parameter 'conceptUid' is set
      if (conceptUid === undefined || conceptUid === null) {
        throw new Error("Missing the required parameter 'conceptUid' when calling updateSpatialUnitConcept");
      }

      // verify the required parameter 'patchspatialunitconcept' is set
      if (patchspatialunitconcept === undefined || patchspatialunitconcept === null) {
        throw new Error("Missing the required parameter 'patchspatialunitconcept' when calling updateSpatialUnitConcept");
      }


      var pathParams = {
        'concept_uid': conceptUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitConceptEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/concepts/{concept_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateSpatialUnitQualitative operation.
     * @callback module:api/SpatialUnitsApi~updateSpatialUnitQualitativeCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SpatialUnitsFeatureEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates a new SpatialUnit
     * Updates SpatialUnit with qualitative base spatial profile
     * @param {String} spatialunitUid Spatial unit UID
     * @param {module:model/RFC6902PatchRequest} patchspatialunit Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/SpatialUnitsApi~updateSpatialUnitQualitativeCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SpatialUnitsFeatureEndpointType}
     */
    this.updateSpatialUnitQualitative = function(spatialunitUid, patchspatialunit, opts, callback) {
      opts = opts || {};
      var postBody = patchspatialunit;

      // verify the required parameter 'spatialunitUid' is set
      if (spatialunitUid === undefined || spatialunitUid === null) {
        throw new Error("Missing the required parameter 'spatialunitUid' when calling updateSpatialUnitQualitative");
      }

      // verify the required parameter 'patchspatialunit' is set
      if (patchspatialunit === undefined || patchspatialunit === null) {
        throw new Error("Missing the required parameter 'patchspatialunit' when calling updateSpatialUnitQualitative");
      }


      var pathParams = {
        'spatialunit_uid': spatialunitUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = SpatialUnitsFeatureEndpointType;

      return this.apiClient.callApi(
        '/spatialunits/qualitative/{spatialunit_uid}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
