/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RFC6902PatchRequest', 'model/TagsEndpointType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/RFC6902PatchRequest'), require('../model/TagsEndpointType'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.TagsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.RFC6902PatchRequest, root.Its4landPublicApi.TagsEndpointType);
  }
}(this, function(ApiClient, RFC6902PatchRequest, TagsEndpointType) {
  'use strict';

  /**
   * Tags service.
   * @module api/TagsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new TagsApi. 
   * @alias module:api/TagsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getTagByName operation.
     * @callback module:api/TagsApi~getTagByNameCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TagsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single tag
     * Returns a tag
     * @param {String} tagName Tag Name
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/TagsApi~getTagByNameCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TagsEndpointType}
     */
    this.getTagByName = function(tagName, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'tagName' is set
      if (tagName === undefined || tagName === null) {
        throw new Error("Missing the required parameter 'tagName' when calling getTagByName");
      }


      var pathParams = {
        'tag_name': tagName
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = TagsEndpointType;

      return this.apiClient.callApi(
        '/tags/{tag_name}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getTags operation.
     * @callback module:api/TagsApi~getTagsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TagsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of tags
     * Get a list of tags
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of Tag UID
     * @param {Array.<String>} opts.displayvalue Comma separated list of Tag display value
     * @param {Array.<String>} opts.objecttypes Comma separated list of objects types
     * @param {Array.<String>} opts.objectuuid Comma separated list of object UID
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of tags
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/TagsApi~getTagsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/TagsEndpointType>}
     */
    this.getTags = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'displayvalue': {
          value: opts['displayvalue'],
          collectionFormat: 'csv'
        },
        'objecttypes': {
          value: opts['objecttypes'],
          collectionFormat: 'csv'
        },
        'objectuuid': {
          value: opts['objectuuid'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [TagsEndpointType];

      return this.apiClient.callApi(
        '/tags', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the mergeTagByUID operation.
     * @callback module:api/TagsApi~mergeTagByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TagsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Merge tags
     * merge tags
     * @param {String} tagUid Tag UID
     * @param {module:model/RFC6902PatchRequest} mergetag Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/TagsApi~mergeTagByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TagsEndpointType}
     */
    this.mergeTagByUID = function(tagUid, mergetag, opts, callback) {
      opts = opts || {};
      var postBody = mergetag;

      // verify the required parameter 'tagUid' is set
      if (tagUid === undefined || tagUid === null) {
        throw new Error("Missing the required parameter 'tagUid' when calling mergeTagByUID");
      }

      // verify the required parameter 'mergetag' is set
      if (mergetag === undefined || mergetag === null) {
        throw new Error("Missing the required parameter 'mergetag' when calling mergeTagByUID");
      }


      var pathParams = {
        'tag_uid': tagUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TagsEndpointType;

      return this.apiClient.callApi(
        '/tags/{tag_uid}/merge', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateTagByName operation.
     * @callback module:api/TagsApi~updateTagByNameCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TagsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Updates a tag
     * Updates a tag
     * @param {String} tagName Tag UID
     * @param {module:model/RFC6902PatchRequest} patchtag Update data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/TagsApi~updateTagByNameCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TagsEndpointType}
     */
    this.updateTagByName = function(tagName, patchtag, opts, callback) {
      opts = opts || {};
      var postBody = patchtag;

      // verify the required parameter 'tagName' is set
      if (tagName === undefined || tagName === null) {
        throw new Error("Missing the required parameter 'tagName' when calling updateTagByName");
      }

      // verify the required parameter 'patchtag' is set
      if (patchtag === undefined || patchtag === null) {
        throw new Error("Missing the required parameter 'patchtag' when calling updateTagByName");
      }


      var pathParams = {
        'tag_name': tagName
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TagsEndpointType;

      return this.apiClient.callApi(
        '/tags/{tag_name}', 'PATCH',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
