/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ToolsEndpointType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/ToolsEndpointType'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ToolsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ToolsEndpointType);
  }
}(this, function(ApiClient, ToolsEndpointType) {
  'use strict';

  /**
   * Tools service.
   * @module api/ToolsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new ToolsApi. 
   * @alias module:api/ToolsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getTools operation.
     * @callback module:api/ToolsApi~getToolsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/ToolsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a list of tools
     * Get a list of tools
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of Tag UID
     * @param {Array.<String>} opts.name Comma separated list of tool names
     * @param {String} opts.version Tool version. By default, the latest version will be returned. * returns all versions.
     * @param {Array.<String>} opts.supplier Comma separated list of supplier
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of fields
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/ToolsApi~getToolsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/ToolsEndpointType>}
     */
    this.getTools = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'version': opts['version'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'supplier': {
          value: opts['supplier'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [ToolsEndpointType];

      return this.apiClient.callApi(
        '/tools', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
