/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/WP5ValidationSetsEndpointType', 'model/WP5ValidationSetsPostRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/WP5ValidationSetsEndpointType'), require('../model/WP5ValidationSetsPostRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.WP5ValidationSetsApi = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.WP5ValidationSetsEndpointType, root.Its4landPublicApi.WP5ValidationSetsPostRequest);
  }
}(this, function(ApiClient, WP5ValidationSetsEndpointType, WP5ValidationSetsPostRequest) {
  'use strict';

  /**
   * WP5ValidationSets service.
   * @module api/WP5ValidationSetsApi
   * @version 0.0.2
   */

  /**
   * Constructs a new WP5ValidationSetsApi. 
   * @alias module:api/WP5ValidationSetsApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the getWP5ValidationSetByUID operation.
     * @callback module:api/WP5ValidationSetsApi~getWP5ValidationSetByUIDCallback
     * @param {String} error Error message, if any.
     * @param {module:model/WP5ValidationSetsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a single WP5ValidationSet
     * Returns a single WP5ValidationSet
     * @param {String} wp5validationsetUid WP5ValidationSet UID
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/WP5ValidationSetsApi~getWP5ValidationSetByUIDCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/WP5ValidationSetsEndpointType}
     */
    this.getWP5ValidationSetByUID = function(wp5validationsetUid, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'wp5validationsetUid' is set
      if (wp5validationsetUid === undefined || wp5validationsetUid === null) {
        throw new Error("Missing the required parameter 'wp5validationsetUid' when calling getWP5ValidationSetByUID");
      }


      var pathParams = {
        'wp5validationset_uid': wp5validationsetUid
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = WP5ValidationSetsEndpointType;

      return this.apiClient.callApi(
        '/WP5ValidationSets/{wp5validationset_uid}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getWP5ValidationSets operation.
     * @callback module:api/WP5ValidationSetsApi~getWP5ValidationSetsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/WP5ValidationSetsEndpointType>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Returns a list of WP5ValidationSets
     * Returns a list of WP5ValidationSets
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.uid Comma separated list of TrainingSet UID
     * @param {Array.<String>} opts.name Comma separated list of WP5ValidationSets Names
     * @param {Array.<String>} opts.models Comma separated list of model UID
     * @param {Array.<String>} opts.projects Comma separated list of project UID
     * @param {Array.<String>} opts.tags Comma separated list of tags
     * @param {Number} opts.page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
     * @param {String} opts.sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
     * @param {Array.<String>} opts.fields Comma separated list of field names
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {module:api/WP5ValidationSetsApi~getWP5ValidationSetsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/WP5ValidationSetsEndpointType>}
     */
    this.getWP5ValidationSets = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
        'page': opts['page'],
        'sort': opts['sort'],
      };
      var collectionQueryParams = {
        'uid': {
          value: opts['uid'],
          collectionFormat: 'csv'
        },
        'name': {
          value: opts['name'],
          collectionFormat: 'csv'
        },
        'models': {
          value: opts['models'],
          collectionFormat: 'csv'
        },
        'projects': {
          value: opts['projects'],
          collectionFormat: 'csv'
        },
        'tags': {
          value: opts['tags'],
          collectionFormat: 'csv'
        },
        'fields': {
          value: opts['fields'],
          collectionFormat: 'csv'
        },
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [WP5ValidationSetsEndpointType];

      return this.apiClient.callApi(
        '/WP5ValidationSets', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the newWP5ValidationSets operation.
     * @callback module:api/WP5ValidationSetsApi~newWP5ValidationSetsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/WP5ValidationSetsEndpointType} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new WP5ValidationSets
     * Create a new TrainingSet. To add a new WP5ValidationSets , the content of WP5ValidationSets  must be stored in advanced via the ContentItem endpoint
     * @param {module:model/WP5ValidationSetsPostRequest} newwp5validationsets New WP5ValidationSet data
     * @param {Object} opts Optional parameters
     * @param {module:model/String} opts.envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
     * @param {Array.<String>} opts.embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
     * @param {String} opts.i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
     * @param {module:api/WP5ValidationSetsApi~newWP5ValidationSetsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/WP5ValidationSetsEndpointType}
     */
    this.newWP5ValidationSets = function(newwp5validationsets, opts, callback) {
      opts = opts || {};
      var postBody = newwp5validationsets;

      // verify the required parameter 'newwp5validationsets' is set
      if (newwp5validationsets === undefined || newwp5validationsets === null) {
        throw new Error("Missing the required parameter 'newwp5validationsets' when calling newWP5ValidationSets");
      }


      var pathParams = {
      };
      var queryParams = {
        'envelope': opts['envelope'],
      };
      var collectionQueryParams = {
        'embed': {
          value: opts['embed'],
          collectionFormat: 'csv'
        },
      };
      var headerParams = {
        'i4l-process-uid': opts['i4lProcessUid']
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = WP5ValidationSetsEndpointType;

      return this.apiClient.callApi(
        '/WP5ValidationSets', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
