/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AdminSourcesEndpointTypeSpatialUnits', 'model/ModelsEndpointTypeProjects'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AdminSourcesEndpointTypeSpatialUnits'), require('./ModelsEndpointTypeProjects'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.AdminSourcesEndpointType = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.AdminSourcesEndpointTypeSpatialUnits, root.Its4landPublicApi.ModelsEndpointTypeProjects);
  }
}(this, function(ApiClient, AdminSourcesEndpointTypeSpatialUnits, ModelsEndpointTypeProjects) {
  'use strict';




  /**
   * The AdminSourcesEndpointType model module.
   * @module model/AdminSourcesEndpointType
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>AdminSourcesEndpointType</code>.
   * Data model of the /adminsources endpoint
   * @alias module:model/AdminSourcesEndpointType
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>AdminSourcesEndpointType</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AdminSourcesEndpointType} obj Optional instance to populate.
   * @return {module:model/AdminSourcesEndpointType} The populated <code>AdminSourcesEndpointType</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('UID')) {
        obj['UID'] = ApiClient.convertToType(data['UID'], 'String');
      }
      if (data.hasOwnProperty('Name')) {
        obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
      }
      if (data.hasOwnProperty('Description')) {
        obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
      }
      if (data.hasOwnProperty('LongDescription')) {
        obj['LongDescription'] = ApiClient.convertToType(data['LongDescription'], 'String');
      }
      if (data.hasOwnProperty('ExtDescriptionURL')) {
        obj['ExtDescriptionURL'] = ApiClient.convertToType(data['ExtDescriptionURL'], 'String');
      }
      if (data.hasOwnProperty('Type')) {
        obj['Type'] = ApiClient.convertToType(data['Type'], 'String');
      }
      if (data.hasOwnProperty('ContentItem')) {
        obj['ContentItem'] = ApiClient.convertToType(data['ContentItem'], 'String');
      }
      if (data.hasOwnProperty('Concept')) {
        obj['Concept'] = ApiClient.convertToType(data['Concept'], 'String');
      }
      if (data.hasOwnProperty('SpatialUnits')) {
        obj['SpatialUnits'] = ApiClient.convertToType(data['SpatialUnits'], [AdminSourcesEndpointTypeSpatialUnits]);
      }
      if (data.hasOwnProperty('Tags')) {
        obj['Tags'] = ApiClient.convertToType(data['Tags'], ['String']);
      }
      if (data.hasOwnProperty('Projects')) {
        obj['Projects'] = ApiClient.convertToType(data['Projects'], [ModelsEndpointTypeProjects]);
      }
    }
    return obj;
  }

  /**
   * UUID of AdminSource
   * @member {String} UID
   */
  exports.prototype['UID'] = undefined;
  /**
   * Freely chosen name
   * @member {String} Name
   */
  exports.prototype['Name'] = undefined;
  /**
   * Free text for description. Only plain text. Max 255 char.
   * @member {String} Description
   */
  exports.prototype['Description'] = undefined;
  /**
   * Text for description. Can contain html. Max 4000 char.
   * @member {String} LongDescription
   */
  exports.prototype['LongDescription'] = undefined;
  /**
   * URL to an external description of the document.
   * @member {String} ExtDescriptionURL
   */
  exports.prototype['ExtDescriptionURL'] = undefined;
  /**
   * Admin Source type.
   * @member {String} Type
   */
  exports.prototype['Type'] = undefined;
  /**
   * UID of the ContentItem
   * @member {String} ContentItem
   */
  exports.prototype['ContentItem'] = undefined;
  /**
   * Zeigt auf ein Konzept (UID) in einer auf LADM aufbauenden Ontologie. Was ist der Unterscheid zu Type? Besserer Name, daa ansosnsten Verwechselung mit Concept aus Models
   * @member {String} Concept
   */
  exports.prototype['Concept'] = undefined;
  /**
   * Array of Spatial Units. The Admin Source document provides the legal evidenace for the registartion of the Spatial Unit in the LAS.
   * @member {Array.<module:model/AdminSourcesEndpointTypeSpatialUnits>} SpatialUnits
   */
  exports.prototype['SpatialUnits'] = undefined;
  /**
   * Array of tags (strings).
   * @member {Array.<String>} Tags
   */
  exports.prototype['Tags'] = undefined;
  /**
   * Array of Projects (UID).
   * @member {Array.<module:model/ModelsEndpointTypeProjects>} Projects
   */
  exports.prototype['Projects'] = undefined;



  return exports;
}));


