/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ProcessEndpointTypeProject', 'model/ProcessEndpointTypeResults', 'model/ProcessEndpointTypeTool'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ProcessEndpointTypeProject'), require('./ProcessEndpointTypeResults'), require('./ProcessEndpointTypeTool'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.ProcessEndpointType = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.ProcessEndpointTypeProject, root.Its4landPublicApi.ProcessEndpointTypeResults, root.Its4landPublicApi.ProcessEndpointTypeTool);
  }
}(this, function(ApiClient, ProcessEndpointTypeProject, ProcessEndpointTypeResults, ProcessEndpointTypeTool) {
  'use strict';




  /**
   * The ProcessEndpointType model module.
   * @module model/ProcessEndpointType
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>ProcessEndpointType</code>.
   * @alias module:model/ProcessEndpointType
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>ProcessEndpointType</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ProcessEndpointType} obj Optional instance to populate.
   * @return {module:model/ProcessEndpointType} The populated <code>ProcessEndpointType</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('UID')) {
        obj['UID'] = ApiClient.convertToType(data['UID'], 'String');
      }
      if (data.hasOwnProperty('Project')) {
        obj['Project'] = ProcessEndpointTypeProject.constructFromObject(data['Project']);
      }
      if (data.hasOwnProperty('Status')) {
        obj['Status'] = ApiClient.convertToType(data['Status'], 'String');
      }
      if (data.hasOwnProperty('CreatedAt')) {
        obj['CreatedAt'] = ApiClient.convertToType(data['CreatedAt'], 'Date');
      }
      if (data.hasOwnProperty('CreatedBy')) {
        obj['CreatedBy'] = ApiClient.convertToType(data['CreatedBy'], 'String');
      }
      if (data.hasOwnProperty('LastModifiedAt')) {
        obj['LastModifiedAt'] = ApiClient.convertToType(data['LastModifiedAt'], 'Date');
      }
      if (data.hasOwnProperty('LastModifiedBy')) {
        obj['LastModifiedBy'] = ApiClient.convertToType(data['LastModifiedBy'], 'String');
      }
      if (data.hasOwnProperty('Tool')) {
        obj['Tool'] = ProcessEndpointTypeTool.constructFromObject(data['Tool']);
      }
      if (data.hasOwnProperty('Logs')) {
        obj['Logs'] = ApiClient.convertToType(data['Logs'], 'String');
      }
      if (data.hasOwnProperty('Results')) {
        obj['Results'] = ApiClient.convertToType(data['Results'], [ProcessEndpointTypeResults]);
      }
    }
    return obj;
  }

  /**
   * UID of the process
   * @member {String} UID
   */
  exports.prototype['UID'] = undefined;
  /**
   * @member {module:model/ProcessEndpointTypeProject} Project
   */
  exports.prototype['Project'] = undefined;
  /**
   * Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. 
   * @member {module:model/ProcessEndpointType.StatusEnum} Status
   */
  exports.prototype['Status'] = undefined;
  /**
   * Creation date
   * @member {Date} CreatedAt
   */
  exports.prototype['CreatedAt'] = undefined;
  /**
   * User name of the creator
   * @member {String} CreatedBy
   */
  exports.prototype['CreatedBy'] = undefined;
  /**
   * Last modification date
   * @member {Date} LastModifiedAt
   */
  exports.prototype['LastModifiedAt'] = undefined;
  /**
   * User name of the last modifier
   * @member {String} LastModifiedBy
   */
  exports.prototype['LastModifiedBy'] = undefined;
  /**
   * @member {module:model/ProcessEndpointTypeTool} Tool
   */
  exports.prototype['Tool'] = undefined;
  /**
   * Logs from the process
   * @member {String} Logs
   */
  exports.prototype['Logs'] = undefined;
  /**
   * Results from the process
   * @member {Array.<module:model/ProcessEndpointTypeResults>} Results
   */
  exports.prototype['Results'] = undefined;


  /**
   * Allowed values for the <code>Status</code> property.
   * @enum {String}
   * @readonly
   */
  exports.StatusEnum = {
    /**
     * value: "WAITING"
     * @const
     */
    "WAITING": "WAITING",
    /**
     * value: "RUNNING"
     * @const
     */
    "RUNNING": "RUNNING",
    /**
     * value: "FINISHED"
     * @const
     */
    "FINISHED": "FINISHED",
    /**
     * value: "ABORTED"
     * @const
     */
    "ABORTED": "ABORTED",
    /**
     * value: "ZOMBIE"
     * @const
     */
    "ZOMBIE": "ZOMBIE"  };


  return exports;
}));


