/**
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SpatialUnitsFeatureEndpointTypePropertiesAdminSource', 'model/SpatialUnitsFeatureEndpointTypePropertiesProjects'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SpatialUnitsFeatureEndpointTypePropertiesAdminSource'), require('./SpatialUnitsFeatureEndpointTypePropertiesProjects'));
  } else {
    // Browser globals (root is window)
    if (!root.Its4landPublicApi) {
      root.Its4landPublicApi = {};
    }
    root.Its4landPublicApi.SpatialUnitBaseFeaturePostRequest = factory(root.Its4landPublicApi.ApiClient, root.Its4landPublicApi.SpatialUnitsFeatureEndpointTypePropertiesAdminSource, root.Its4landPublicApi.SpatialUnitsFeatureEndpointTypePropertiesProjects);
  }
}(this, function(ApiClient, SpatialUnitsFeatureEndpointTypePropertiesAdminSource, SpatialUnitsFeatureEndpointTypePropertiesProjects) {
  'use strict';




  /**
   * The SpatialUnitBaseFeaturePostRequest model module.
   * @module model/SpatialUnitBaseFeaturePostRequest
   * @version 0.0.2
   */

  /**
   * Constructs a new <code>SpatialUnitBaseFeaturePostRequest</code>.
   * Post Request of he /adminsources endpoint
   * @alias module:model/SpatialUnitBaseFeaturePostRequest
   * @class
   * @param name {String} Freely chosen name
   * @param description {String} Free text for description. Only plain text. Max 255 char.
   */
  var exports = function(name, description) {
    var _this = this;

    _this['Name'] = name;
    _this['Description'] = description;







  };

  /**
   * Constructs a <code>SpatialUnitBaseFeaturePostRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SpatialUnitBaseFeaturePostRequest} obj Optional instance to populate.
   * @return {module:model/SpatialUnitBaseFeaturePostRequest} The populated <code>SpatialUnitBaseFeaturePostRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('Name')) {
        obj['Name'] = ApiClient.convertToType(data['Name'], 'String');
      }
      if (data.hasOwnProperty('Description')) {
        obj['Description'] = ApiClient.convertToType(data['Description'], 'String');
      }
      if (data.hasOwnProperty('LongDescription')) {
        obj['LongDescription'] = ApiClient.convertToType(data['LongDescription'], 'String');
      }
      if (data.hasOwnProperty('ExtDescriptionURL')) {
        obj['ExtDescriptionURL'] = ApiClient.convertToType(data['ExtDescriptionURL'], 'String');
      }
      if (data.hasOwnProperty('Level')) {
        obj['Level'] = ApiClient.convertToType(data['Level'], 'String');
      }
      if (data.hasOwnProperty('Concept')) {
        obj['Concept'] = ApiClient.convertToType(data['Concept'], 'String');
      }
      if (data.hasOwnProperty('AdminSource')) {
        obj['AdminSource'] = ApiClient.convertToType(data['AdminSource'], [SpatialUnitsFeatureEndpointTypePropertiesAdminSource]);
      }
      if (data.hasOwnProperty('BoundaryFaceString')) {
        obj['BoundaryFaceString'] = ApiClient.convertToType(data['BoundaryFaceString'], 'String');
      }
      if (data.hasOwnProperty('Projects')) {
        obj['Projects'] = ApiClient.convertToType(data['Projects'], [SpatialUnitsFeatureEndpointTypePropertiesProjects]);
      }
    }
    return obj;
  }

  /**
   * Freely chosen name
   * @member {String} Name
   */
  exports.prototype['Name'] = undefined;
  /**
   * Free text for description. Only plain text. Max 255 char.
   * @member {String} Description
   */
  exports.prototype['Description'] = undefined;
  /**
   * Text for description. Can contain html. Max 4000 char.
   * @member {String} LongDescription
   */
  exports.prototype['LongDescription'] = undefined;
  /**
   * URL to an external description of the document.
   * @member {String} ExtDescriptionURL
   */
  exports.prototype['ExtDescriptionURL'] = undefined;
  /**
   * Level according to LADM
   * @member {String} Level
   */
  exports.prototype['Level'] = undefined;
  /**
   * According to the ontology based on LADM
   * @member {String} Concept
   */
  exports.prototype['Concept'] = undefined;
  /**
   * Related Admin Source Documents
   * @member {Array.<module:model/SpatialUnitsFeatureEndpointTypePropertiesAdminSource>} AdminSource
   */
  exports.prototype['AdminSource'] = undefined;
  /**
   * UUID to a boundary face string
   * @member {String} BoundaryFaceString
   */
  exports.prototype['BoundaryFaceString'] = undefined;
  /**
   * Related Projects
   * @member {Array.<module:model/SpatialUnitsFeatureEndpointTypePropertiesProjects>} Projects
   */
  exports.prototype['Projects'] = undefined;



  return exports;
}));


